// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ___Library_impl_h__
#define ___Library_impl_h__

#include <Library_skel.h>

//
// IDL:Book:1.0
//
class Book_impl : virtual public POA_Book,
                  virtual public PortableServer::RefCountServantBase
{
    Book_impl(const Book_impl&);
    void operator=(const Book_impl&);

    PortableServer::POA_var poa_;
    PortableServer::Current_var current_;
    BookInfoSeq bookInfos_;

public:

    Book_impl(PortableServer::POA_ptr, PortableServer::Current_ptr,
	      const BookInfoSeq&);
    ~Book_impl();

    virtual PortableServer::POA_ptr _default_POA();

    //
    // IDL:Book/info:1.0
    //
    virtual BookInfo* info()
        throw(CORBA::SystemException);
};

//
// IDL:Library:1.0
//
class Library_impl : virtual public POA_Library,
                     virtual public PortableServer::RefCountServantBase
{
    Library_impl(const Library_impl&);
    void operator=(const Library_impl&);

    PortableServer::POA_var poa_;
    BookInfoSeq bookInfos_;

public:

    Library_impl(PortableServer::POA_ptr, const BookInfoSeq&);
    ~Library_impl();

    virtual PortableServer::POA_ptr _default_POA();

    //
    // IDL:Library/get_book:1.0
    //
    virtual Book_ptr get_book(const char* title)
        throw(CORBA::SystemException);

    //
    // IDL:Library/get_titles:1.0
    //
    virtual BookTitles* get_titles()
        throw(CORBA::SystemException);
};

#endif
