// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

#ifndef __OB_StrategyProxy_impl_h__
#define __OB_StrategyProxy_impl_h__

#include <OB/Balancer_skel.h>

#include <BalancerLogger_fwd.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// IDL:ooc.com/LoadBalancing/StrategyProxy:1.0
//
class StrategyProxy_impl : virtual public POA_LoadBalancing::StrategyProxy,
                           virtual public PortableServer::RefCountServantBase,
			   public JTCMutex
{
    StrategyProxy_impl(const StrategyProxy_impl&);
    void operator=(const StrategyProxy_impl&);

    //
    // The POA
    //
    PortableServer::POA_var poa_;

    //
    // The logger
    //
    Logger_var logger_;

    //
    // The strategy
    //
    Strategy_var strategy_;

public:

    StrategyProxy_impl(PortableServer::POA_ptr, Logger_ptr, Strategy_ptr);
    ~StrategyProxy_impl();

    virtual PortableServer::POA_ptr _default_POA();

    //
    // Set the strategy.
    //
    void setStrategy(Strategy_ptr strategy);

    //
    // IDL:ooc.com/LoadBalancing/StrategyProxy/get_name:1.0
    //
    virtual char* get_name()
        throw(CORBA::SystemException);

    //
    // IDL:ooc.com/LoadBalancing/StrategyProxy/get_properties:1.0
    //
    virtual PropertySeq* get_properties()
        throw(CORBA::SystemException);

    //
    // IDL:ooc.com/LoadBalancing/StrategyProxy/push_load:1.0
    //
    virtual void push_load(const char* member_id,
                           CORBA::ULong load)
        throw(LoadBalancing::MemberNotFound,
              LoadBalancing::StrategyNotAdaptive,
              CORBA::SystemException);
};

} // End of namespace LoadBalancing

#endif
