// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <LoadAlertInterceptor.h>
#include <LoadAlert_impl.h>

using namespace CORBA;

// ----------------------------------------------------------------------
// LoadAlert_impl constructor and destructor
// ----------------------------------------------------------------------

LoadBalancing::Util::LoadAlert_impl::LoadAlert_impl(
    LoadAlertInterceptor* interceptor)
    : interceptor_(interceptor)
{
    assert(interceptor_ != 0);

#ifdef LB_DEBUG
    OB_CERR << "LoadAlert_impl::LoadAlert_impl()" << OB_ENDL;
#endif
}

LoadBalancing::Util::LoadAlert_impl::~LoadAlert_impl()
{
#ifdef LB_DEBUG
    OB_CERR << "LoadAlert_impl::~LoadAlert_impl()" << OB_ENDL;
#endif
}

// ----------------------------------------------------------------------
// LoadAlert_impl public member implementation
// ----------------------------------------------------------------------

void
LoadBalancing::Util::LoadAlert_impl::alert()
    throw(CORBA::SystemException)
{
    interceptor_ -> alert();
}

CORBA::ULong
LoadBalancing::Util::LoadAlert_impl::get_alert_expire()
    throw(CORBA::SystemException)
{
    return interceptor_ -> getExpire();
}

void
LoadBalancing::Util::LoadAlert_impl::set_alert_expire(CORBA::ULong millis)
    throw(CORBA::SystemException)
{
    interceptor_ -> setExpire(millis);
}
