# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

CLIENT_NAME	= client.exe
SERVER_NAME	= server.exe

TARGETS		= $(CLIENT_NAME) \
		  $(SERVER_NAME)

!include $(top_srcdir)\config\Make.rules.mak

COMMON_OBJS	= Tester.obj

CLIENT_OBJS	= Client.obj

SERVER_OBJS	= Server.obj \
		  Tester_skel.obj \
		  Tester_impl.obj \
		  MemberObject.obj \
		  MemberObject_skel.obj \
		  MemberObject_impl.obj \
		  CustomStrategy_impl.obj \
		  TestGroupFactory.obj \
		  TestGroup.obj \
		  TestRandom.obj \
		  TestRoundRobin.obj \
		  TestLeastLoad.obj \
		  TestMinDisp.obj \
		  TestCustom.obj \
		  TestPersistence.obj \
		  TestAdministrative.obj

ALL_CXXFLAGS	= $(CXXFLAGS) /Zm200
ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(top_srcdir)\lib\Balancer$(LIBSUFFIX).lib $(OB_LIBS) $(LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(COMMON_OBJS)
	-del $@
        $(LINK) $(LINKFLAGS) /out:$@ \
        $(CLIENT_OBJS) $(COMMON_OBJS) $(ALL_LIBS)

$(SERVER_NAME): $(SERVER_OBJS) $(COMMON_OBJS)
	-del $@
        $(LINK) $(LINKFLAGS) /out:$@ \
        $(SERVER_OBJS) $(COMMON_OBJS) $(ALL_LIBS)

MemberObject.cpp MemberObject.h: MemberObject.idl
	-del MemberObject.cpp MemberObject.h
	-del MemberObject_skel.cpp MemberObject_skel.h
	$(IDL) --no-type-codes MemberObject.idl

MemberObject_skel.cpp MemberObject_skel.h: MemberObject.cpp

Tester.cpp Tester.h: Tester.idl
	-del Tester.cpp Tester.h
	-del Tester_skel.cpp Tester_skel.h
	$(IDL) --no-type-codes Tester.idl

Tester_skel.cpp Tester_skel.h: Tester.cpp

!include .windep
