dnl -----------------------------------------------------------------------
dnl BerkeleyDB specific configuration
dnl The "--with-berkeleydb" option must be used to enable BerkeleyDB support
dnl -----------------------------------------------------------------------

AC_SUBST(WITH_BERKELEYDB)
AC_SUBST(BERKELEYDB_CPPFLAGS)
AC_SUBST(BERKELEYDB_LDFLAGS)
AC_SUBST(BERKELEYDB_LIBS)
WITH_BERKELEYDB=no
BERKELEYDB_CPPFLAGS=
BERKELEYDB_LDFLAGS=
BERKELEYDB_LIBS=

AC_ARG_WITH(berkeleydb,
  --with-berkeleydb=path     make use of BerkeleyDB,
if test "$with_berkeleydb" != "no"
then
    AC_MSG_CHECKING(BerkeleyDB)
    if test -z "$with_berkeleydb" -o "$with_berkeleydb" = "yes"
    then
        AC_MSG_RESULT(no)
	AC_MSG_ERROR(Can't find BerkeleyDB! Use the --with-berkeleydb=path option.)
    fi
    BERKELEYDB_CPPFLAGS=-I${with_berkeleydb}/include
    BERKELEYDB_LDFLAGS=-L${with_berkeleydb}/lib
    BERKELEYDB_LIBS=-ldb
    AC_MSG_RESULT(${with_berkeleydb})
    WITH_BERKELEYDB=yes
fi
)

