dnl **********************************************************************
dnl
dnl Copyright (c) 2002
dnl IONA Technologies, Inc.
dnl Waltham, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OBEVENT_CPPFLAGS)
AC_SUBST(OBEVENT_LDFLAGS)
AC_SUBST(OBEVENT_IDLDIR)
AC_SUBST(OBEVENT_LIBS)
AC_SUBST(WITH_OBEVENT)

OBEVENT_CPPFLAGS=
OBEVENT_LDFLAGS=
OBEVENT_IDLDIR=
OBEVENT_LIBS=
WITH_OBEVENT=no

AC_ARG_WITH(obevent,
  --with-obevent=DIR      make use of the Event Service,
)

dnl
dnl Discover the ORBacus Events path
dnl

obevent_path=

if test -z "$obevent_path" -a -n "$with_obevent" -a "$with_obevent" != "yes"
then
    if test "$with_obevent" = "no"
    then
	AC_MSG_ERROR(ORBacus Events required!)
    fi

    dnl
    dnl Search in the directory specified by the --with-obevent option
    dnl
    obevent_path="${with_obevent}/"
    if test ! -f ${obevent_path}include/OB/EventService.h
    then
	obevent_path="${obevent_path}event/"
    fi
fi

if test -z "$obevent_path" -a -n "$with_ob" -a "$with_ob" != "yes"
then
    dnl
    dnl Search in the directory specified by the --with-ob option
    dnl
    obevent_path="${with_ob}/"
    if test ! -f ${obevent_path}include/OB/EventService.h
    then
    	obevent_path="${with_ob}/event/"
	if test ! -f ${obevent_path}include/OB/EventService.h
    	then
	    obevent_path=
    	fi
    fi
fi

if test -z "$obevent_path" -a -n "$prefix"
then
    dnl
    dnl Search in the installation directory
    dnl
    obevent_path="${prefix}/"
    if test ! -f ${obevent_path}include/OB/EventService.h
    then
	obevent_path="${obevent_path}event/"
	if test ! -f ${obevent_path}include/OB/EventService.h
	then
	    obevent_path=
	fi
    fi	
fi

if test -z "$obevent_path"
then
    obevent_path="../event/"
fi

if test ! -f ${obevent_path}include/OB/EventService.h
then
   AC_MSG_ERROR(Can't find ORBacus Events! Use the --with-obevent=DIR option.)
fi

if test "$obevent_path" = "../event/"
then
    obevent_path="\$(top_srcdir)/$obevent_path"
fi

OBEVENT_CPPFLAGS="$OBEVENT_CPPFLAGS -I${obevent_path}include"
OBEVENT_LDFLAGS="$OBEVENT_LDFLAGS -L${obevent_path}lib"
OBEVENT_IDLDIR="${obevent_path}idl"
OBEVENT_LIBS="$OBEVENT_LIBS -lOBEventService -lOBEvent"
AC_DEFINE(HAVE_OBEVENT)
WITH_OBEVENT=yes
