dnl **********************************************************************
dnl
dnl Copyright (c) 2002
dnl IONA Technologies, Inc.
dnl Waltham, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl ORBacus-specific configuration
dnl ----------------------------------------------------------------------

AC_SUBST(OBTIME_CPPFLAGS)
AC_SUBST(OBTIME_LDFLAGS)
AC_SUBST(OBTIME_LIBS)
AC_SUBST(OBTIME_IDLFLAGS)

OBTIME_CPPFLAGS=
OBTIME_LDFLAGS=
OBTIME_LIBS=
OBTIME_IDLFLAGS=

AC_ARG_WITH(obtime,
  --with-obtime=DIR       make use of the Time Service,
)

obtime_path=

if test -z "$obtime_path" -a -n "$with_obtime" -a "$with_obtime" != "yes"
then
    if test "$with_obtime" = "no"
    then
	AC_MSG_ERROR(ORBacus Time Service required!)
    fi

    dnl
    dnl Search in the directory specified by the --with-ob option
    dnl
    obtime_path="${with_obtime}/"
    if test ! -f ${obtime_path}include/OB/TimeService.h
    then
	obtime_path="${obtime_path}time/"
	if test ! -f ${obtime_path}include/OB/TimeService.h
	then
	    obtime_path=
	fi
    fi
fi

if test -z "$obtime_path" -a -n "$with_ob" -a "$with_ob" != "yes"
then
    dnl
    dnl Search in the directory specified by the --with-ob option
    dnl
    obtime_path="${with_ob}/"
    if test ! -f ${obtime_path}include/OB/TimeService.h
    then
	obtime_path="${obtime_path}time/"
	if test ! -f ${obtime_path}include/OB/TimeService.h
	then
	    obtime_path=
	fi
    fi
fi

if test -z "$obtime_path"
then
    dnl
    dnl Search in the current directory or ../time
    dnl	
    obtime_path="./"
    if test ! -f ${obtime_path}include/OB/TimeService.h
    then
	obtime_path="../time/"
	if test ! -f ${obtime_path}include/OB/TimeService.h
	then
	    obtime_path=
	fi
    fi
fi

if test -z "$obtime_path" -a -n "$prefix"
then
    dnl
    dnl Search in the installation directory
    dnl
    obtime_path="${prefix}/"
    if test ! -f ${obtime_path}include/OB/TimeService.h
    then
	obtime_path="${obtime_path}time/"
	if test ! -f ${obtime_path}include/OB/TimeService.h
	then
	    obtime_path=
	fi
    fi	
fi

dnl
dnl If we didn't find the Time Service directory print an error message
dnl 
if test ! -f ${obtime_path}include/OB/TimeService.h
then
    AC_MSG_ERROR(Can't find ORBacus Time Service library! Use the --with-ob=path option or the --with-obtime=path option if the ORBacus Time Service is not installed in the ORBacus directory.)
fi

dnl
dnl Add "$(top_srcdir)" to relative paths (current directory and ../time)
dnl
if test "$obtime_path" = "./"
then
    obtime_path="\$(top_srcdir)/"
fi

if test "$obtime_path" = "../time/"
then
    obtime_path="\$(top_srcdir)/../time/"
fi

OBTIME_LDFLAGS="$OBTIME_LDFLAGS -L${obtime_path}lib"
OBTIME_CPPFLAGS="$OBTIME_CPPFLAGS -I${obtime_path}include"
OBTIME_LIBS="$OBTIME_LIBS -lCosTime"
OBTIME_IDLFLAGS="$OBTIME_IDLFLAGS -I${obtime_path}idl"
