dnl **********************************************************************
dnl
dnl Copyright (c) 2002
dnl IONA Technologies, Inc.
dnl Waltham, MA, USA
dnl
dnl All Rights Reserved
dnl
dnl **********************************************************************

dnl ----------------------------------------------------------------------
dnl Check for X11 libraries
dnl ----------------------------------------------------------------------

AC_PATH_XTRA

AC_SUBST(WITH_X11)
AC_SUBST(OB_X11_CPPFLAGS)
AC_SUBST(OB_X11_PRE_LIBS)
AC_SUBST(OB_X11_LIBS)

if test -z "$no_x"
then
    WITH_X11=yes
    AC_CHECK_HEADERS(X11/Intrinsic.h)
else
    WITH_X11=no
fi

OB_X11_CPPFLAGS=
OB_X11_CFLAGS=
OB_X11_PRE_LIBS=
OB_X11_LIBS=

if test "$WITH_X11" = yes
then
  OB_X11_CPPFLAGS="$X_CFLAGS"
  OB_X11_PRE_LIBS="-lOBX11"
  OB_X11_LIBS="$X_LIBS $X_PRE_LIBS -lXt -lX11 $X_EXTRA_LIBS"
fi

dnl --------------------------------------------------------------------------
dnl Check whether GNU C++ requires X11-based applications
dnl to be compiled with -fpermissive
dnl --------------------------------------------------------------------------

if test "$WITH_X11" = yes -a "$GXX" = yes
then
  AC_CACHE_CHECK(for broken X11 header files,
  ac_cv_permissive,
  AC_TRY_COMPILE_GLOBAL(
  ,
  #include <X11/Intrinsic.h>
  ,
  ac_cv_permissive=no, ac_cv_permissive=yes)
  )

  if test $ac_cv_permissive = yes
  then
      OB_X11_CPPFLAGS="$OB_X11_CPPFLAGS -fpermissive"
  fi
fi
