// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_PROXY_PULL_SUPPLIER_IMPL_H
#define COS_PROXY_PULL_SUPPLIER_IMPL_H

//
// Forward declarations
//
class EC_PullPipeSegment;

//
// The event channel ProxyPullSupplier implementation
//
class EC_ProxyPullSupplier_impl :
    public POA_CosEventChannelAdmin::ProxyPullSupplier,
    public ProxyBase
{
    //
    // No copy constructor/assignment operator.
    //
    EC_ProxyPullSupplier_impl(const EC_ProxyPullSupplier_impl&);
    void operator=(const EC_ProxyPullSupplier_impl&);

    EC_PullPipeSegment* pullPipe_; // My pull pipe segment

    CosEventComm::PullConsumer_var consumer_; // My pull consumer
    
    CORBA::ULong maxEvents_; // Maximum number of pending events
    
    int canReap_; // Can this proxy be reaped?

public:

    EC_ProxyPullSupplier_impl(ProxyConstructorInfo&);
    ~EC_ProxyPullSupplier_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual void connect_pull_consumer(CosEventComm::PullConsumer_ptr)
	throw(CosEventChannelAdmin::AlreadyConnected,
	      CORBA::SystemException);

    virtual CORBA::Any* pull()
	throw(CosEventComm::Disconnected,
	      CORBA::SystemException);

    virtual CORBA::Any* try_pull(CORBA::Boolean&)
	throw(CosEventComm::Disconnected,
	      CORBA::SystemException);

    virtual void disconnect_pull_supplier()
	throw(CORBA::SystemException);

    //
    // Internal methods
    //

    //
    // Disconnect the servant from the ORB
    //
    virtual void deactivateObject();

    //
    // Called during disconnect
    //
    virtual void disconnectPeer();

    //
    // Can this proxy be reaped?
    //
    virtual bool canReap();
};

#endif
