// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_SUPPLIER_ADMIN_IMPL_H
#define COS_SUPPLIER_ADMIN_IMPL_H

//
// Forward declarations.
//
class Reaper;

//
// Event channel SupplierAdmin
//
class EC_SupplierAdmin_impl : public POA_CosEventChannelAdmin::SupplierAdmin,
			      public AdminBase
{
    //
    // No copy constructor/assignment operator
    //
    EC_SupplierAdmin_impl(const EC_SupplierAdmin_impl&);
    void operator=(const EC_SupplierAdmin_impl&);

    virtual void deactivateObject();

public:

    EC_SupplierAdmin_impl(CORBA::ORB_ptr, PortableServer::POA_ptr,
			  OB::EventLogger_ptr, Reaper*, PipeSegment_ptr);
    ~EC_SupplierAdmin_impl();

    //
    // Standard IDL to C++ Mapping
    //

    //
    // Get ProxyPushSupplier.
    //
    virtual CosEventChannelAdmin::ProxyPushConsumer_ptr obtain_push_consumer()
	throw(CORBA::SystemException);

    //
    // Get ProxyPullSupplier.
    //
    virtual CosEventChannelAdmin::ProxyPullConsumer_ptr obtain_pull_consumer()
	throw(CORBA::SystemException);
};

#endif
