// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/OCI_IIOP.h>

#include <EventUtil.h>

using namespace CORBA;

// ----------------------------------------------------------------------
// EventUtil public member implementation
// ----------------------------------------------------------------------

char*
EventUtil::getConnectionAddrDescription(ORB_ptr orb)
{
    Object_var obj;
    try
    {
        obj = orb -> resolve_initial_references("OCICurrent");
    }
    catch(const ORB::InvalidName&)
    {
    }
    assert(!is_nil(obj));
    OCI::Current_var current = OCI::Current::_narrow(obj);
    assert(!is_nil(current));
    OCI::TransportInfo_var info = current -> get_oci_transport_info();

    String_var desc;
    if(!is_nil(info))
        desc = info -> describe();
    else
        desc = string_dup("UNKNOWN");

    return desc._retn();
}

