// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

#ifndef REAPER_H
#define REAPER_H

//
// Forward declarations.
//
class ProxyBase;
typedef OB_STL::list< ProxyBase* > ProxyPtrList;

class Reaper : public JTCThread, public JTCMonitor
{
    //
    // The message logger
    //
    OB::EventLogger_var logger_;

    //
    // Is the reaper done?
    //
    bool done_;

    //
    // How long does the reaper sleep between reaps (seconds)?
    //
    long sleepTime_;

    //
    // How long can a proxy be inactive before its reaped (seconds)?
    //
    time_t reapTime_;

    //
    // All proxies
    //
    ProxyPtrList proxies_;

    void reap();

public:

    Reaper(CORBA::ORB_ptr, OB::EventLogger_ptr);
    ~Reaper();

    void add(ProxyBase*);

    void destroy();

    virtual void run();
};

typedef JTCHandleT<Reaper> ReaperHandle;

#endif
