// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_TYPED_PROXY_PUSH_SUPPLIER_IMPL_H
#define COS_TYPED_PROXY_PUSH_SUPPLIER_IMPL_H

//
// The Event Channel ProxyPushSupplier implementation
//
class TEC_ProxyPushSupplier_impl :
    public POA_CosEventChannelAdmin::ProxyPushSupplier,
    public ProxyBase
{
    //
    // No copy constructor/assignment operator
    //
    TEC_ProxyPushSupplier_impl(const TEC_ProxyPushSupplier_impl&);
    void operator=(const TEC_ProxyPushSupplier_impl&);
    
    CosEventComm::PushConsumer_var consumer_; // My consumer

public:
    
    TEC_ProxyPushSupplier_impl(ProxyConstructorInfo&);
    ~TEC_ProxyPushSupplier_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual void connect_push_consumer(CosEventComm::PushConsumer_ptr)
	throw(CosEventChannelAdmin::AlreadyConnected, CORBA::SystemException);
    virtual void disconnect_push_supplier()
	throw(CORBA::SystemException);

    //
    // Internal methods
    //

    //
    // Disconnect the servant from the ORB
    //
    virtual void deactivateObject();

    //
    // Called during disconnect
    //
    virtual void disconnectPeer();

    //
    // Can this proxy be reaped?
    //
    virtual bool canReap();
};

#endif
