// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_TYPED_CONSUMER_ADMIN_IMPL_H
#define COS_TYPED_CONSUMER_ADMIN_IMPL_H

//
// Forward declarations
//
class ChannelType;
class Reaper;

//
// The event channel ConsumerAdmin class
// 
class TEC_TypedConsumerAdmin_impl :
    public POA_CosTypedEventChannelAdmin::TypedConsumerAdmin,
    public AdminBase
{
    //
    // No copy constructor/assignment operator
    //
    TEC_TypedConsumerAdmin_impl(const TEC_TypedConsumerAdmin_impl&);
    void operator=(const TEC_TypedConsumerAdmin_impl&);

    ChannelType* type_; // The channel type

    virtual void deactivateObject();
    
public:

    TEC_TypedConsumerAdmin_impl(CORBA::ORB_ptr, PortableServer::POA_ptr,
    				OB::EventLogger_ptr, Reaper*,
				PipeSegment_ptr, ChannelType*);
    ~TEC_TypedConsumerAdmin_impl();

    //
    // Standard IDL to C++ Mapping
    //

    //
    // Get ProxyPushConsumer.
    //
    virtual CosEventChannelAdmin::ProxyPushSupplier_ptr
    obtain_push_supplier()
	throw(CORBA::SystemException);

    //
    // Get ProxyPullConsumer.
    //
    virtual CosEventChannelAdmin::ProxyPullSupplier_ptr
    obtain_pull_supplier()
	throw(CORBA::SystemException);

    //
    // Get ProxyPullSupplier.
    //
    virtual CosTypedEventChannelAdmin::TypedProxyPullSupplier_ptr
    obtain_typed_pull_supplier(const char*)
	throw(CosTypedEventChannelAdmin::InterfaceNotSupported,
	      CORBA::SystemException);

    //
    // Get ProxyPushSupplier.
    //
    virtual CosEventChannelAdmin::ProxyPushSupplier_ptr
    obtain_typed_push_supplier(const char*)
    throw(CosTypedEventChannelAdmin::NoSuchImplementation,
	  CORBA::SystemException);
};

#endif
