// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_TYPED_PROXY_PUSH_SUPPLIER_IMPL_H
#define COS_TYPED_PROXY_PUSH_SUPPLIER_IMPL_H

//
// Forward declarations
//
class TypedProxyPushConsumerDSI_impl;
class ChannelType;

//
// The Event Channel ProxyPushConsumer implementation
//
class TEC_TypedProxyPushConsumer_impl :
    public POA_CosTypedEventChannelAdmin::TypedProxyPushConsumer,
    public ProxyBase
{
    //
    // No copy constructor/assignment operator
    //
    TEC_TypedProxyPushConsumer_impl(const TEC_TypedProxyPushConsumer_impl&);
    void operator=(const TEC_TypedProxyPushConsumer_impl&);
    
    CosEventComm::PushSupplier_var supplier_; // My supplier

    TypedProxyPushConsumerDSI_impl* dsiImpl_; // The DSI implementation

    CORBA::Object_var dsiRef_; // A reference to the DSI implementation

public:
    
    TEC_TypedProxyPushConsumer_impl(ProxyConstructorInfo&, ChannelType*);
    ~TEC_TypedProxyPushConsumer_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual CORBA::Object_ptr get_typed_consumer()
	throw(CORBA::SystemException);

    virtual void connect_push_supplier(CosEventComm::PushSupplier_ptr)
	throw(CosEventChannelAdmin::AlreadyConnected,
	      CORBA::SystemException);

    virtual void disconnect_push_consumer()
	throw(CORBA::SystemException);

    virtual void push(const CORBA::Any&)
	throw(CosEventComm::Disconnected,
	      CORBA::SystemException);

    //
    // Internal methods
    //

    //
    // Disconnect the servant from the ORB
    //
    virtual void deactivateObject();

    //
    // Called during disconnect
    //
    virtual void disconnectPeer();

    //
    // Provides the implementation of discardRequests() without
    // synchronization
    //
    virtual void discardRequestsImpl();

    //
    // Can this proxy be reaped?
    //
    virtual bool canReap();
};

#endif
