// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
#ifndef COS_TYPED_SUPPLIER_ADMIN_IMPL_H
#define COS_TYPED_SUPPLIER_ADMIN_IMPL_H

//
// Forward declarations
//
class ChannelType;
class Reaper;

//
// The typed event channel SupplierAdmin
//
class TEC_TypedSupplierAdmin_impl :
    public POA_CosTypedEventChannelAdmin::TypedSupplierAdmin,
    public AdminBase
{
    //
    // No copy constructor/assignment operator
    //
    TEC_TypedSupplierAdmin_impl(const TEC_TypedSupplierAdmin_impl&);
    void operator=(const TEC_TypedSupplierAdmin_impl&);
    
    ChannelType* type_; // The channel type

    virtual void deactivateObject();
    
public:

    TEC_TypedSupplierAdmin_impl(CORBA::ORB_ptr, PortableServer::POA_ptr,
    				OB::EventLogger_ptr, Reaper*,
				PipeSegment_ptr, ChannelType*);
    ~TEC_TypedSupplierAdmin_impl();

    //
    // Standard IDL to C++ Mapping
    //

    //
    // Get ProxyPushConsumer.
    //
    virtual CosEventChannelAdmin::ProxyPushConsumer_ptr
    obtain_push_consumer()
	throw(CORBA::SystemException);

    //
    // Get ProxyPullConsumer.
    //
    virtual CosEventChannelAdmin::ProxyPullConsumer_ptr
    obtain_pull_consumer()
	throw(CORBA::SystemException);

    //
    // Get ProxyPullSupplier.
    //
    virtual CosTypedEventChannelAdmin::TypedProxyPushConsumer_ptr
    obtain_typed_push_consumer(const char*)
	throw(CosTypedEventChannelAdmin::InterfaceNotSupported,
	      CORBA::SystemException);

    //
    // Get ProxyPushSupplier.
    //
    virtual CosEventChannelAdmin::ProxyPullConsumer_ptr
    obtain_typed_pull_consumer(const char*)
	throw(CosTypedEventChannelAdmin::NoSuchImplementation,
	      CORBA::SystemException);
};

#endif
