# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir 	= ..

ADMIN_NAME = Admin.exe
PUSHEVENTCLIENT_NAME = pusheventclient.exe
PULLEVENTCLIENT_NAME = pulleventclient.exe
PUSHEVENTSERVER_NAME = pusheventserver.exe
PULLEVENTSERVER_NAME = pulleventserver.exe

TYPEDPUSHEVENTCLIENT_NAME = typedpusheventclient.exe
TYPEDPUSHEVENTSERVER_NAME = typedpusheventserver.exe

TARGETS         = $(ADMIN_NAME) \
                  $(PUSHEVENTCLIENT_NAME) \
                  $(PUSHEVENTSERVER_NAME) \
                  $(PULLEVENTSERVER_NAME) \
                  $(PULLEVENTCLIENT_NAME) \
		  $(TYPEDPUSHEVENTSERVER_NAME) \
		  $(TYPEDPUSHEVENTCLIENT_NAME)
    
!include $(top_srcdir)\config\Make.rules.mak

ADMIN_OBJS	= Admin.obj TestSuiteUtilities.obj

PUSHEVENTCLIENT_OBJS = PushEventClient.obj TestSuiteUtilities.obj

PUSHEVENTSERVER_OBJS = PushEventServer.obj TestSuiteUtilities.obj

PULLEVENTCLIENT_OBJS = PullEventClient.obj TestSuiteUtilities.obj

PULLEVENTSERVER_OBJS = PullEventServer.obj TestSuiteUtilities.obj

TYPED_COMMON_OBJS = Echo.obj

TYPEDPUSHEVENTSERVER_OBJS = TypedPushEventServer.obj TestSuiteUtilities.obj

TYPEDPUSHEVENTCLIENT_OBJS = TypedPushEventClient.obj TestSuiteUtilities.obj \
			    Echo_skel.obj

ALL_CXXFLAGS	= $(CXXFLAGS)
ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include \
		  $(OBUTIL_CPPFLAGS) $(OB_CPPFLAGS) $(CPPFLAGS)
ALL_LIBS	= $(top_srcdir)\lib\CosEvent$(LIBSUFFIX).lib \
                  $(OBUTIL_LIBS) $(OB_LIBS) $(LIBS) 

all:: $(TARGETS)

$(ADMIN_NAME): $(ADMIN_OBJS)
	$(LINK) $(LINKFLAGS) /out:$@ $(ADMIN_OBJS) $(ALL_LIBS)

$(PUSHEVENTSERVER_NAME): $(PUSHEVENTSERVER_OBJS)
	$(LINK) $(LINKFLAGS) /out:$@ $(PUSHEVENTSERVER_OBJS) $(ALL_LIBS)

$(PUSHEVENTCLIENT_NAME): $(PUSHEVENTCLIENT_OBJS)
	$(LINK) $(LINKFLAGS) /out:$@ $(PUSHEVENTCLIENT_OBJS) $(ALL_LIBS)

$(PULLEVENTCLIENT_NAME): $(PULLEVENTCLIENT_OBJS)
        $(LINK) $(LINKFLAGS) /out:$@ $(PULLEVENTCLIENT_OBJS) $(ALL_LIBS)

$(PULLEVENTSERVER_NAME): $(PULLEVENTSERVER_OBJS)
        $(LINK) $(LINKFLAGS) /out:$@ $(PULLEVENTSERVER_OBJS) $(ALL_LIBS)

$(TYPEDPUSHEVENTSERVER_NAME): $(TYPEDPUSHEVENTSERVER_OBJS) \
	$(TYPED_COMMON_OBJS) $(TYPED_COMMON_OBJS)
        $(LINK) $(LINKFLAGS) /out:$@ $(TYPEDPUSHEVENTSERVER_OBJS) \
	$(TYPED_COMMON_OBJS) $(ALL_LIBS)

$(TYPEDPUSHEVENTCLIENT_NAME): $(TYPEDPUSHEVENTCLIENT_OBJS) \
	$(TYPED_COMMON_OBJS) $(TYPED_COMMON_OBJS)
        $(LINK) $(LINKFLAGS) /out:$@ $(TYPEDPUSHEVENTCLIENT_OBJS) \
	$(TYPED_COMMON_OBJS) $(ALL_LIBS)

Echo.cpp Echo.h: Echo.idl
        -del Echo.cpp Echo.h
        -del Echo_skel.cpp Echo_skel.h
        $(IDL) -I$(top_srcdir)\idl --no-type-codes Echo.idl

Echo_skel.cpp Echo_skel.h : Echo.cpp

!include .windep
