# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

NAME		= $(top_srcdir)\lib\jtc$(LIBSUFFIX).lib
PDB_NAME        = $(top_srcdir)\lib\jtc$(LIBSUFFIX).pdb

TARGETS		= $(NAME)
PDB_FILES       = $(PDB_NAME)

!include $(top_srcdir)\config\Make.rules.mak

OBJS		= Cond.obj \
		  Mutex.obj \
		  RWMutex.obj \
		  Thread.obj \
		  Monitor.obj \
		  Sync.obj \
		  ThreadGroup.obj \
		  TSS.obj \
		  TSSManager.obj \
		  Version.obj

# Also in non-DLL mode needed for the clean target
DEF_NAME	= jtc.def
DLL_NAME	= $(top_srcdir)\lib\jtc$(JTC_LIBVER)$(LIBSUFFIX).dll
EXP_NAME	= $(top_srcdir)\lib\jtc$(LIBSUFFIX).exp

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS) 
ALL_CPPFLAGS	= /DJTC_BUILD_DLL /I. $(JTC_CPPFLAGS) $(CPPFLAGS)
ALL_DLLLIBS	= $(DLLLIBS)

$(NAME): $(DLL_NAME)

$(DEF_NAME): 

$(DLL_NAME): $(OBJS) $(DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
	JTC$(JTC_LIBVER)$(LIBSUFFIX) $(OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x63000000 /def:$(DEF_NAME) /out:$@ \
	/IMPLIB:$(NAME) $(OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) /Fd$(PDB_NAME)
ALL_CPPFLAGS	= /I. $(JTC_CPPFLAGS) $(CPPFLAGS)

$(NAME): $(OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(OBJS)

!endif

$(top_srcdir)\include\JTC\WinConfig.h: $(top_srcdir)\..\config\WinConfig.h
	copy $(top_srcdir)\..\config\WinConfig.h $@

$(top_srcdir)\include\JTC\Config.h: $(top_srcdir)\include\JTC\WinConfig.h \
				    $(top_srcdir)\..\config\Make.rules.mak
	-if exist $@ del $@
!if "$(WITH_JTC_NO_IOSTREAM)" == "yes"
	echo #define HAVE_JTC_NO_IOSTREAM 1 >> $@
!else
	echo /* #undef HAVE_JTC_NO_IOSTREAM */ >> $@
!endif
!if "$(DLL)" == "yes"
	echo #define JTC_DLL 1 >> $@
!else
	echo /* #undef JTC_DLL */ >> $@
!endif
!if "$(OLD_IOSTREAM)" != "yes"
	echo #define HAVE_IOSTREAM 1 >> $@
!else
	echo /* #undef HAVE_IOSTREAM */ >> $@
!endif
	echo #include "WinConfig.h" >> $@

clean::
	-@del $(top_srcdir)\include\JTC\Config.h

install:: all
	copy $(NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
	copy $(DLL_NAME) $(libdir)
	copy $(EXP_NAME) $(libdir)
	if exist $(DLL_PDB) copy $(DLL_PDB) $(libdir)

clean::
	if exist $(DLL_PDB) del $(DLL_PDB)

!endif

clean::
	-@del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) 

min:: all

install_min:: install

!include .windep
