// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************


#include <OB/CORBA.h>
#include <OB/Hashtable.h>
#include <OB/ObjectIdHasher.h>
#include <OB/Codec.h>

#include <OB/OBNaming_skel.h>

#include <Types.h>

#include <stdio.h>

#include <Compactor.h>
#include <OBNaming_impl.h>
#include <NamingDatabase.h>

using namespace CosNaming;

// ----------------------------------------------------------------------
// Compactor constructor/destructor
// ----------------------------------------------------------------------

Compactor::Compactor(NamingDatabase* store, long interval)
    : store_(store),
      interval_(interval),
      stop_(false)
{
}

Compactor::~Compactor()
{
}

// ----------------------------------------------------------------------
// Compactor public member implementation
// ----------------------------------------------------------------------

void
Compactor::start()
{
    JTCSynchronized sync(*this);

    JTCThread::start();
}

void
Compactor::halt()
{
    JTCSynchronized sync(*this);

    stop_ = true;
    JTCMonitor::notify();
}

void
Compactor::run()
{
    JTCSynchronized sync(*this);

    while(!stop_)
    {
	try
	{
	    wait(interval_*1000);
	}
	catch(const JTCInterruptedException&)
	{
	}
	if(!stop_)
	    store_ -> updateJournal();
    }
}
