// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

//
// Class: BasicTester_impl
// A POA servant which implements of the Benchmark::BasicTester interface
//

#ifndef BENCHMARK_BASICTESTERIMPL_H_
#define BENCHMARK_BASICTESTERIMPL_H_

#include <Benchmark_skel.h>

class BasicTester_impl : public virtual POA_Benchmark::BasicTester,
			 public PortableServer::RefCountServantBase
{
    PortableServer::POA_var m_poa;

public:

    BasicTester_impl(
	PortableServer::POA_ptr poa
    );

    virtual ~BasicTester_impl();

    virtual PortableServer::POA_ptr
    _default_POA();

    //
    // IDL operations
    //
    virtual void ping()
        throw(CORBA::SystemException);

    virtual void short_in_t(CORBA::Short)
        throw(CORBA::SystemException);

    virtual void short_out_t(CORBA::Short_out)
        throw(CORBA::SystemException);

    virtual void short_inout_t(CORBA::Short&)
        throw(CORBA::SystemException);

    virtual CORBA::Short short_ret_t()
        throw(CORBA::SystemException);

    virtual void long_in_t(CORBA::Long)
        throw(CORBA::SystemException);

    virtual void long_out_t(CORBA::Long_out)
        throw(CORBA::SystemException);

    virtual void long_inout_t(CORBA::Long&)
        throw(CORBA::SystemException);

    virtual CORBA::Long long_ret_t()
        throw(CORBA::SystemException);

    virtual void longlong_in_t(CORBA::LongLong)
        throw(CORBA::SystemException);

    virtual void longlong_out_t(CORBA::LongLong_out)
        throw(CORBA::SystemException);

    virtual void longlong_inout_t(CORBA::LongLong&)
        throw(CORBA::SystemException);

    virtual CORBA::LongLong longlong_ret_t()
        throw(CORBA::SystemException); 

    virtual void ushort_in_t(CORBA::UShort)
        throw(CORBA::SystemException);

    virtual void ushort_out_t(CORBA::UShort_out)
        throw(CORBA::SystemException);

    virtual void ushort_inout_t(CORBA::UShort&)
        throw(CORBA::SystemException);

    virtual CORBA::UShort ushort_ret_t()
        throw(CORBA::SystemException); 
    
    virtual void ulong_in_t(CORBA::ULong)
        throw(CORBA::SystemException);

    virtual void ulong_out_t(CORBA::ULong_out)
        throw(CORBA::SystemException);

    virtual void ulong_inout_t(CORBA::ULong&)
        throw(CORBA::SystemException);

    virtual CORBA::ULong ulong_ret_t()
        throw(CORBA::SystemException); 
    
    virtual void ulonglong_in_t(CORBA::ULongLong)
        throw(CORBA::SystemException);

    virtual void ulonglong_out_t(CORBA::ULongLong_out)
        throw(CORBA::SystemException);

    virtual void ulonglong_inout_t(CORBA::ULongLong&)
        throw(CORBA::SystemException);

    virtual CORBA::ULongLong ulonglong_ret_t()
        throw(CORBA::SystemException);

    virtual void float_in_t(CORBA::Float)
        throw(CORBA::SystemException);

    virtual void float_out_t(CORBA::Float_out)
        throw(CORBA::SystemException);

    virtual void float_inout_t(CORBA::Float&)
        throw(CORBA::SystemException);

    virtual CORBA::Float float_ret_t()
        throw(CORBA::SystemException);

    virtual void double_in_t(CORBA::Double)
        throw(CORBA::SystemException);

    virtual void double_out_t(CORBA::Double_out)
        throw(CORBA::SystemException);

    virtual void double_inout_t(CORBA::Double&)
        throw(CORBA::SystemException);

    virtual CORBA::Double double_ret_t()
        throw(CORBA::SystemException);

/*
    virtual void longdouble_in_t(CORBA::LongDouble)
        throw(CORBA::SystemException);

    virtual void longdouble_out_t(CORBA::LongDouble_out)
        throw(CORBA::SystemException);

    virtual void longdouble_inout_t(CORBA::LongDouble&)
        throw(CORBA::SystemException);

    virtual CORBA::LongDouble longdouble_ret_t()
        throw(CORBA::SystemException);
*/

    virtual void char_in_t(CORBA::Char)
        throw(CORBA::SystemException);

    virtual void char_out_t(CORBA::Char_out)
        throw(CORBA::SystemException);

    virtual void char_inout_t(CORBA::Char&)
        throw(CORBA::SystemException);

    virtual CORBA::Char char_ret_t()
        throw(CORBA::SystemException);

    virtual void wchar_in_t(CORBA::WChar)
        throw(CORBA::SystemException);

    virtual void wchar_out_t(CORBA::WChar_out)
        throw(CORBA::SystemException);

    virtual void wchar_inout_t(CORBA::WChar&)
        throw(CORBA::SystemException);

    virtual CORBA::WChar wchar_ret_t()
        throw(CORBA::SystemException);

    virtual void string_in_t(const char*)
        throw(CORBA::SystemException);

    virtual void string_out_t(CORBA::String_out)
        throw(CORBA::SystemException);

    virtual void string_inout_t(char*&)
        throw(CORBA::SystemException);

    virtual char* string_ret_t()
        throw(CORBA::SystemException);

    virtual void wstring_in_t(const CORBA::WChar*)
        throw(CORBA::SystemException);

    virtual void wstring_out_t(CORBA::WString_out)
        throw(CORBA::SystemException);

    virtual void wstring_inout_t(CORBA::WChar*&)
        throw(CORBA::SystemException);

    virtual CORBA::WChar* wstring_ret_t()
        throw(CORBA::SystemException); 
    
    virtual void boolean_in_t(CORBA::Boolean)
        throw(CORBA::SystemException);

    virtual void boolean_out_t(CORBA::Boolean_out)
        throw(CORBA::SystemException);

    virtual void boolean_inout_t(CORBA::Boolean&)
        throw(CORBA::SystemException);

    virtual CORBA::Boolean boolean_ret_t()
        throw(CORBA::SystemException);

    virtual void octet_in_t(CORBA::Octet)
        throw(CORBA::SystemException);

    virtual void octet_out_t(CORBA::Octet_out)
        throw(CORBA::SystemException);

    virtual void octet_inout_t(CORBA::Octet&)
        throw(CORBA::SystemException);

    virtual CORBA::Octet octet_ret_t()
        throw(CORBA::SystemException);

    virtual void any_in_t(const CORBA::Any&)
        throw(CORBA::SystemException);

    virtual void any_out_t(CORBA::Any_out)
        throw(CORBA::SystemException);

    virtual void any_inout_t(CORBA::Any&)
        throw(CORBA::SystemException);

    virtual CORBA::Any* any_ret_t()
        throw(CORBA::SystemException);

private: 

    //
    // The following are not implemented
    //
    BasicTester_impl(const BasicTester_impl &);
    BasicTester_impl& operator=(const BasicTester_impl &);
}; 

#endif
