// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

//
// Class: UserTypeTester_impl
// A POA servant which implements of the Benchmark::UserTypeTester interface
//

#ifndef BENCHMARK_USERTYPETESTERIMPL_H_
#define BENCHMARK_USERTYPETESTERIMPL_H_

#include <Benchmark_skel.h>

class UserTypeTester_impl :
    public virtual POA_Benchmark::UserTypeTester,
    public PortableServer::RefCountServantBase
{
    PortableServer::POA_var m_poa;

public:

    UserTypeTester_impl(
	PortableServer::POA_ptr poa
    );

    virtual ~UserTypeTester_impl();

    virtual PortableServer::POA_ptr
    _default_POA();

    //
    // IDL operations
    //
    virtual void u1_in_t(const UserTypes::u1& u)
        throw(CORBA::SystemException);

    virtual void u1_out_t(UserTypes::u1_out u)
        throw(CORBA::SystemException);

    virtual void u1_inout_t(UserTypes::u1& u)
        throw(CORBA::SystemException);

    virtual UserTypes::u1 u1_ret_t()
        throw(CORBA::SystemException);

    virtual void u2_in_t(const UserTypes::u2& u)
        throw(CORBA::SystemException);

    virtual void u2_out_t(UserTypes::u2_out u)
        throw(CORBA::SystemException);

    virtual void u2_inout_t(UserTypes::u2& u)
        throw(CORBA::SystemException);

    virtual UserTypes::u2* u2_ret_t()
        throw(CORBA::SystemException);

    virtual void s1_in_t(const UserTypes::s1& s)
        throw(CORBA::SystemException);

    virtual void s1_out_t(UserTypes::s1_out s)
        throw(CORBA::SystemException);

    virtual void s1_inout_t(UserTypes::s1& s)
        throw(CORBA::SystemException);

    virtual UserTypes::s1 s1_ret_t()
        throw(CORBA::SystemException);

    virtual void s2_in_t(const UserTypes::s2& s)
        throw(CORBA::SystemException);

    virtual void s2_out_t(UserTypes::s2_out s)
        throw(CORBA::SystemException);

    virtual void s2_inout_t(UserTypes::s2& s)
        throw(CORBA::SystemException);

    virtual UserTypes::s2* s2_ret_t()
        throw(CORBA::SystemException);

    virtual void interface_in_t(UserTypes::I_ptr interf)
        throw(CORBA::SystemException);

    virtual void interface_out_t(UserTypes::I_out interf)
        throw(CORBA::SystemException);

    virtual void interface_inout_t(UserTypes::I_ptr& interf)
        throw(CORBA::SystemException);

    virtual UserTypes::I_ptr interface_ret_t()
        throw(CORBA::SystemException);

private: 

    //
    // The following are not implemented
    //
    UserTypeTester_impl(const UserTypeTester_impl &);
    UserTypeTester_impl& operator=(const UserTypeTester_impl &);
}; 

#endif
