// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef RECEIVER_IMPL_H
#define RECEIVER_IMPL_H

#include <Broadcaster.h>
#include <ReceiverBase_impl.h>


namespace chat 
{


class Receiver_impl : public ReceiverBase_impl,
		      public PortableServer::RefCountServantBase
{
    //
    // Some widgets
    //
    Widget parent_;
    Widget textOutput_;

    //
    // Set window title
    //
    void setTitle();

    //
    // Create action area
    //
    Widget createActionArea(Widget);

    //
    // Subscribe with the server
    //
    void subscribe();

public:

    Receiver_impl(Widget, 
                  CORBA::ORB_ptr, 
	          PortableServer::POA_ptr, 
	          BroadcasterAdmin_ptr);

    //
    // Callbacks
    //
    void textInput(Widget);

    //
    // Operations from the .idl file
    //
    virtual void print(const char*)
        throw(CORBA::SystemException);

}; // class Receiver_impl


}; // namespace chat

#endif
