// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef CUSTOMER_IMPL_H
#define CUSTOMER_IMPL_H

//
// IDL:Customer:1.0
//
class Customer_impl : virtual public OBV_Customer,
                      virtual public CORBA::DefaultValueRefCountBase
{
    Customer_impl(const Customer_impl&);
    void operator=(const Customer_impl&);

public:

    Customer_impl();
    ~Customer_impl();

    CORBA::OctetSeq* encrypt(const char*);
    char* decrypt(const CORBA::OctetSeq&);

    //
    // Inherited from CORBA::ValueBase
    //
    virtual CORBA::ValueBase* _copy_value();

    //
    // Inherited from CORBA::CustomMarshal
    //
    virtual void marshal(CORBA::DataOutputStream* os);
    virtual void unmarshal(CORBA::DataInputStream* is);
};

class CustomerFactory_impl : virtual public CORBA::ValueFactoryBase
{
    //
    // Inherited from CORBA::ValueFactoryBase
    //
    virtual CORBA::ValueBase* create_for_unmarshal();

public:
    
    CustomerFactory_impl();
    ~CustomerFactory_impl();
};

#endif
