// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef DATABASE_H
#define DATABASE_H

//
// This structure represents the data in a database object
//
struct DBRecordData
{
    CORBA::String_var data;
    long key;
};

//
// A sequence of the data
//
typedef OB::FixSeq<DBRecordData*, int> DBRecordDataPtrSeq;

//
// This represents the persistent database of DBRecord data. Note that
// this is only for demonstration purposes.
//
class Database
{
    DBRecordDataPtrSeq records_; // Set of records in the database

public:

    ~Database();

    //
    // Destroy the record specified by `key'
    //
    bool destroy(long key);

    //
    // Add a record specified by `key'
    //
    DBRecordData* add(long key);

    //
    // Find the record specified by `key'
    //
    DBRecordData* find(long key);

    //
    // Return the record at position i
    //
    DBRecordData* recordAt(CORBA::ULong i);

    //
    // Return the number of records in database
    //
    CORBA::ULong size();
};

#endif
