// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef DEFAULT_FACTORY_IMPL_H
#define DEFAULT_FACTORY_IMPL_H

#include <Factory_skel.h>

//
// Forward declaration
//
class Database;

//
// This factory uses a default servant to implement the record objects
//
class DefaultFactory_impl : public POA_DBFactory,
			    public PortableServer::RefCountServantBase
{
    CORBA::Long nextKey_; // Next available key
    Database* database_;
    CORBA::ORB_var orb_;
    PortableServer::POA_var poa_;
    PortableServer::POA_var mypoa_;

    DBRecord_ptr makeRef(CORBA::Long key);

public:

    DefaultFactory_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr parent);
    virtual ~DefaultFactory_impl();

    virtual DBRecord_ptr createRecord()
        throw(CORBA::SystemException);

    virtual void destroyByKey(CORBA::Long key)
        throw(DBFactory::NoRecord, CORBA::SystemException);

    virtual DBRecord_ptr getByKey(CORBA::Long key)
        throw(DBFactory::NoRecord, CORBA::SystemException);

    virtual DBFactory::DBRecordKeySeq* getAllKeys()
        throw(CORBA::SystemException);

    virtual PortableServer::POA_ptr _default_POA();
};

#endif
