// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef LOCATOR_FACTORY_IMPL_H
#define LOCATOR_FACTORY_IMPL_H

#include <Factory_skel.h>

//
// Forward declarations
//
class Database;
class Reaper;
class ReapTimer;
class Locator;

typedef JTCHandleT<ReapTimer> ReapTimerHandle;

//
// The LocatorFactory_impl class
//
class LocatorFactory_impl : public POA_DBFactory,
			    public PortableServer::RefCountServantBase
{
    CORBA::Long nextKey_;
    Database* database_;
    CORBA::ORB_var orb_;
    PortableServer::POA_var poa_;
    PortableServer::POA_var mypoa_;
    Reaper* reaper_;
    ReapTimerHandle timer_;
    Locator* locator_;

    PortableServer::ObjectId* makeKey(CORBA::Long key);
    DBRecord_ptr makeRef(CORBA::Long key);

public:

    LocatorFactory_impl(CORBA::ORB_ptr orb, PortableServer::POA_ptr parent,
    			bool debug);
    virtual ~LocatorFactory_impl();

    virtual DBRecord_ptr createRecord()
        throw(CORBA::SystemException);

    virtual void destroyByKey(CORBA::Long key)
        throw(DBFactory::NoRecord, CORBA::SystemException);

    virtual DBRecord_ptr getByKey(CORBA::Long key)
        throw(DBFactory::NoRecord, CORBA::SystemException);

    virtual DBFactory::DBRecordKeySeq* getAllKeys()
        throw(CORBA::SystemException);

    virtual PortableServer::POA_ptr _default_POA();
};

#endif
