// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <ReapTimer.h>
#include <Reaper.h>

// ----------------------------------------------------------------------
// ReapTimer constructor/destructor
// ----------------------------------------------------------------------

ReapTimer::ReapTimer(Reaper* reaper, int interval)
    : reaper_(reaper), interval_(interval), destroy_(false)
{
}

ReapTimer::~ReapTimer()
{
}

// ----------------------------------------------------------------------
// ReapTimer public member implementation
// ----------------------------------------------------------------------

void
ReapTimer::run()
{
    JTCSynchronized sync(*this);

    while(!destroy_)
    {
	try
	{
	    wait(interval_ * 1000);
	}
	catch(const JTCInterruptedException&)
	{
	}
	reaper_ -> reap();
    }
}

void
ReapTimer::destroy()
{
    JTCSynchronized sync(*this);

    destroy_ = true;
    notifyAll();
}
