// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef REAPER_H
#define REAPER_H

//
// Abstract class that defines the interface for a servant reaper
//
class Reaper
{
    Reaper(const Reaper&);
    Reaper& operator=(const Reaper&);

protected:

    Reaper() { }

public:

    virtual ~Reaper() { }

    virtual void
    addServant(const PortableServer::ObjectId& oid,
               PortableServer::Servant servant) = 0;

    virtual void
    removeServant(const PortableServer::ObjectId& oid) = 0;

    virtual PortableServer::Servant
    acquireServant(const PortableServer::ObjectId& oid) = 0;
    
    virtual void
    releaseServant(const PortableServer::ObjectId& oid) = 0;
    
    virtual void reap() = 0;
};

//
// Abstract class that defines a callback to be invoked when a servant
// has been reaped
//
class ReapListener
{
public:

    virtual void servantReaped(const PortableServer::ObjectId& oid,
                               PortableServer::Servant servant) = 0;
};

#endif
