// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OAD_DATABASE_H
#define OAD_DATABASE_H

#include <OB/Hashtable.h>

#include <IMRDB.h>
#include <Database.h>

namespace IMR
{

//
// An OAD Database
//
class OADDatabase : public JTCMonitor
{
    //
    // The message logger
    //
    OB::Logger_var logger_;

    //
    // The database
    //
    OB::Database* db_;

    //
    // Mapping of host name to OAD Record
    //
    typedef OB::Hashtable<CORBA::String_var, IMRDB_4_0_2::OADRecord,
    			  OB::StringHasher> HostTable;
    HostTable* oads_;
			  
    void load();

public:

    OADDatabase(CORBA::ORB_ptr);
    ~OADDatabase();

    bool queryRecordByHost(const char*, IMRDB_4_0_2::OADRecord&,
    			   bool partial = false);

    void addRecord(IMRDB_4_0_2::OADRecord&);

    void updateRecord(const IMRDB_4_0_2::OADRecord&);

    void removeRecord(const char*);

    IMRDB_4_0_2::OADRecordSeq* getAllRecords();
};

} // End namspace IMR

#endif
