// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <ObjectLocator.h>

using namespace IMR;

// ----------------------------------------------------------------------
// ObjectLocator constructor
// ----------------------------------------------------------------------

ObjectLocator::ObjectLocator(CORBA::ORB_ptr orb)
    : orb_(CORBA::ORB::_duplicate(orb))
{
}

// ----------------------------------------------------------------------
// Standard IDL/C++ mapping
// ----------------------------------------------------------------------

void
ObjectLocator::locate(const PortableServer::ObjectId& oid,
                      CORBA::Object_out obj,
		      CORBA::Boolean_out add)
    throw(OB::BootManager::NotFound)
{
    try
    {
        CORBA::String_var name = PortableServer::ObjectId_to_string(oid);
        obj = orb_ -> resolve_initial_references(name);
	add = true;
    }
    catch(const CORBA::ORB::InvalidName&)
    {
        throw OB::BootManager::NotFound();
    }
}
