// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef PROCESS_OBSERVER_H
#define PROCESS_OBSERVER_H

#include <IMROAD_fwd.h>

#include <OB/IMRTypes.h>

namespace OAD
{

//
// Forward declarations
//
class ProcessDatabase;

class ProcObserver
{
    //
    // The process database
    //
    ProcessDatabase* db_;

    //
    // The ServerObserver
    //
    IMR::ServerObserver_var observer_;

    //
    // The Trace Levels
    //
    IMROAD::Logger_var logger_;

    JTCMutex observerMutex_;

public:

    ProcObserver(ProcessDatabase*, IMROAD::Logger_ptr);

    //
    // Notify the observer that a new process has been created
    //
    void processCreate(const char*, const char*, IMR::ProcessID);

    //
    // Notify the observer that a process has died
    //
    void processDestroy(const char*, const char*);
    void processDestroy(IMR::ProcessID);

    void setObserver(IMR::ServerObserver_ptr);
    IMR::ServerObserver_ptr getObserver();
};

} // End namespace OAD

#endif
