// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef PROCESS_DATABASE_H
#define PROCESS_DATABASE_H

#include <OB/IMRTypes.h>
#include <OADDB.h>
#include <Database.h>

namespace OAD
{

class ProcessDatabase : public JTCMonitor
{
    //
    // The Logger
    //
    OB::Logger_var logger_;

    //
    // The Database
    //
    OB::Database* db_;

    //
    // The child processes
    //
    OADDB_4_0_2::ServerRecordSeq children_;

    void load();

public:

    ProcessDatabase(CORBA::ORB_ptr);
    ~ProcessDatabase();

    void updateRecord(const OADDB_4_0_2::ServerRecord&);

    bool createRecord(const char*, const char*, IMR::ProcessID, 
    		      OADDB_4_0_2::ServerRecord&);

    bool queryServerByName(const char*, OADDB_4_0_2::ServerRecord&);

    bool queryServerById(const char*, const char*, OADDB_4_0_2::ServerRecord&);

    bool queryServerByPid(IMR::ProcessID, OADDB_4_0_2::ServerRecord&);

    OADDB_4_0_2::ServerRecordSeq* getAllServers();

    void removeRecord(const char*);
};

} // End namespace OAD

#endif
