// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef SERVER_FACTORY_IMPL_H
#define SERVER_FACTORY_IMPL_H

#include <OB/IMR_skel.h>

#include <IMRLogger_fwd.h>

namespace IMR
{

//
// Forward declarations
//
class OADDatabase;
class Server_impl;
class ServerDatabase;
class ServerStarter;

class ServerFactory_impl : public POA_IMR::ServerFactory
{
    ServerDatabase* db_;
    OADDatabase* oaddb_;
    PortableServer::POA_var serverPOA_;
    PortableServer::POA_var poa_;
    Server_impl* server_;
    bool administrative_;

    Server_ptr createServerReference(CORBA::Long);

public:

    ServerFactory_impl(ServerDatabase*, OADDatabase*, CORBA::ORB_ptr,
                       PortableServer::POA_ptr, IMROAD::Logger_ptr, bool,
		       ServerStarter*);
    ~ServerFactory_impl();

    //
    // Standard IDL to C++ Mapping
    //

    //
    // Mapping for IMR::ServerFactory
    //
    virtual Server_ptr get_server(const char*)
	throw(NoSuchServer,
	      CORBA::SystemException);

    //
    // Mapping for IMR::ServerFactory
    //
    virtual Server_ptr create_server_record(const char*)
	throw(IMR::ServerAlreadyRegistered,
              CORBA::SystemException);

    virtual ServerSeq* list_servers()
	throw(CORBA::SystemException);

    virtual ServerSeq* list_servers_by_host(const char*)
	throw(CORBA::SystemException);

    virtual ServerSeq* list_orphaned_servers()
	throw(CORBA::SystemException);

    virtual PortableServer::POA_ptr _default_POA();
};

}; // End namespace IMR

#endif
