// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Environment.h>
#include <OB/Except.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(CORBA::Environment_ptr p)
{
    if(p)
	p -> _OB_incRef();
}

void
OBRelease(CORBA::Environment_ptr p)
{
    if(p)
	p -> _OB_decRef();
}

// ----------------------------------------------------------------------
// Environment constructor and destructor
// ----------------------------------------------------------------------

Environment::Environment()
    : exception_(0)
{
}

Environment::~Environment()
{
    delete exception_;
}

// ----------------------------------------------------------------------
// Environment public member implementation
// ----------------------------------------------------------------------

void
Environment::exception(Exception* p)
{
    delete exception_;
    exception_ = p;
}

Exception*
Environment::exception() const
{
    return exception_;
}
