// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <Messaging_impl.h>

using namespace CORBA;
using namespace OB;

// ----------------------------------------------------------------------
// RebindPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::RebindPolicy_impl::RebindPolicy_impl(RebindMode value)
    : value_(value)
{
}

Messaging::RebindPolicy_impl::~RebindPolicy_impl()
{
}

// ----------------------------------------------------------------------
// RebindPolicy_impl public member implementation
// ----------------------------------------------------------------------

Messaging::RebindMode
Messaging::RebindPolicy_impl::rebind_mode()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::RebindPolicy_impl::policy_type()
    throw(SystemException)
{
    return REBIND_POLICY_TYPE;
}

Policy_ptr
Messaging::RebindPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::RebindPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// SyncScopePolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::SyncScopePolicy_impl::SyncScopePolicy_impl(SyncScope value)
    : value_(value)
{
}

Messaging::SyncScopePolicy_impl::~SyncScopePolicy_impl()
{
}

// ----------------------------------------------------------------------
// SyncScopePolicy_impl public member implementation
// ----------------------------------------------------------------------

Messaging::SyncScope
Messaging::SyncScopePolicy_impl::synchronization()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::SyncScopePolicy_impl::policy_type()
    throw(SystemException)
{
    return SYNC_SCOPE_POLICY_TYPE;
}

Policy_ptr
Messaging::SyncScopePolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::SyncScopePolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// RequestStartTimePolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::RequestStartTimePolicy_impl::RequestStartTimePolicy_impl(
    TimeBase::UtcT value)
    : value_(value)
{
}

Messaging::RequestStartTimePolicy_impl::~RequestStartTimePolicy_impl()
{
}

// ----------------------------------------------------------------------
// RequestStartTimePolicy_impl public member implementation
// ----------------------------------------------------------------------

TimeBase::UtcT
Messaging::RequestStartTimePolicy_impl::start_time()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::RequestStartTimePolicy_impl::policy_type()
    throw(SystemException)
{
    return REQUEST_START_TIME_POLICY_TYPE;
}

Policy_ptr
Messaging::RequestStartTimePolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::RequestStartTimePolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// RequestEndTimePolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::RequestEndTimePolicy_impl::RequestEndTimePolicy_impl(
    TimeBase::UtcT value)
    : value_(value)
{
}

Messaging::RequestEndTimePolicy_impl::~RequestEndTimePolicy_impl()
{
}

// ----------------------------------------------------------------------
// RequestEndTimePolicy_impl public member implementation
// ----------------------------------------------------------------------

TimeBase::UtcT
Messaging::RequestEndTimePolicy_impl::end_time()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::RequestEndTimePolicy_impl::policy_type()
    throw(SystemException)
{
    return REQUEST_END_TIME_POLICY_TYPE;
}

Policy_ptr
Messaging::RequestEndTimePolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::RequestEndTimePolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// ReplyStartTimePolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::ReplyStartTimePolicy_impl::ReplyStartTimePolicy_impl(
    TimeBase::UtcT value)
    : value_(value)
{
}

Messaging::ReplyStartTimePolicy_impl::~ReplyStartTimePolicy_impl()
{
}

// ----------------------------------------------------------------------
// ReplyStartTimePolicy_impl public member implementation
// ----------------------------------------------------------------------

TimeBase::UtcT
Messaging::ReplyStartTimePolicy_impl::start_time()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::ReplyStartTimePolicy_impl::policy_type()
    throw(SystemException)
{
    return REPLY_START_TIME_POLICY_TYPE;
}

Policy_ptr
Messaging::ReplyStartTimePolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::ReplyStartTimePolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// ReplyEndTimePolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::ReplyEndTimePolicy_impl::ReplyEndTimePolicy_impl(
    TimeBase::UtcT value)
    : value_(value)
{
}

Messaging::ReplyEndTimePolicy_impl::~ReplyEndTimePolicy_impl()
{
}

// ----------------------------------------------------------------------
// ReplyEndTimePolicy_impl public member implementation
// ----------------------------------------------------------------------

TimeBase::UtcT
Messaging::ReplyEndTimePolicy_impl::end_time()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::ReplyEndTimePolicy_impl::policy_type()
    throw(SystemException)
{
    return REPLY_END_TIME_POLICY_TYPE;
}

Policy_ptr
Messaging::ReplyEndTimePolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::ReplyEndTimePolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// RelativeRequestTimeoutPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::RelativeRequestTimeoutPolicy_impl::
RelativeRequestTimeoutPolicy_impl(
    TimeBase::TimeT value)
    : value_(value)
{
}

Messaging::RelativeRequestTimeoutPolicy_impl::
~RelativeRequestTimeoutPolicy_impl()
{
}

// ----------------------------------------------------------------------
// RelativeRequestTimeoutPolicy_impl public member implementation
// ----------------------------------------------------------------------

TimeBase::TimeT
Messaging::RelativeRequestTimeoutPolicy_impl::relative_expiry()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::RelativeRequestTimeoutPolicy_impl::policy_type()
    throw(SystemException)
{
    return RELATIVE_REQ_TIMEOUT_POLICY_TYPE;
}

Policy_ptr
Messaging::RelativeRequestTimeoutPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::RelativeRequestTimeoutPolicy_impl::destroy()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// RelativeRoundTripTimeoutPolicy_impl constructor and destructor
// ----------------------------------------------------------------------

Messaging::RelativeRoundTripTimeoutPolicy_impl::
RelativeRoundTripTimeoutPolicy_impl(
    TimeBase::TimeT value)
    : value_(value)
{
}

Messaging::RelativeRoundTripTimeoutPolicy_impl::
~RelativeRoundTripTimeoutPolicy_impl()
{
}

// ----------------------------------------------------------------------
// RelativeRoundTripTimeoutPolicy_impl public member implementation
// ----------------------------------------------------------------------

TimeBase::TimeT
Messaging::RelativeRoundTripTimeoutPolicy_impl::relative_expiry()
    throw(SystemException)
{
    return value_;
}

PolicyType
Messaging::RelativeRoundTripTimeoutPolicy_impl::policy_type()
    throw(SystemException)
{
    return RELATIVE_RT_TIMEOUT_POLICY_TYPE;
}

Policy_ptr
Messaging::RelativeRoundTripTimeoutPolicy_impl::copy()
    throw(SystemException)
{
    return Policy::_duplicate(this);
}

void
Messaging::RelativeRoundTripTimeoutPolicy_impl::destroy()
    throw(SystemException)
{
}
