// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_MODULE_MANAGER_H
#define OB_MODULE_MANAGER_H

#include <OB/Logger_fwd.h>

#include <OB/list.h>

namespace OB
{

//
// Forward declaration
//
class SharedLibrary;

//
// The ModuleManager class
//
class ModuleManager // : public OB::SimpleRefCount
{
    //
    // Hide copy-constructor and assignment operator
    //
    ModuleManager(const ModuleManager&);
    void operator=(const ModuleManager&);

public: // Some compilers require these types to be public

    //
    // Module data
    //
    struct ModuleData
    {
        CORBA::String_var name;
        SharedLibrary* lib;
    };

private:

    //
    // The set of registered modules
    //
    OB_STL::list<ModuleData> modules_;

    void initialize(Properties_ptr, Logger_ptr, const char*);

public:

    ModuleManager();
    virtual ~ModuleManager();

    void load(Properties_ptr, Logger_ptr, const char*);
};

} // End of namespace OB

#endif
