// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_OAD_PROC_CONTROL_IMPL_H
#define OB_OAD_PROC_CONTROL_IMPL_H

#include <OB/MarshalStubImpl.h>
#include <OB/DirectStubImpl.h>
#include <OB/POAServantBase.h>
#include <OB/POAInterface.h>
#include <OB/ORBControl.h>
#include <OB/OADProcessEndpoint_skel.h>

namespace OAD
{

class ProcessEndpoint_impl : public POA_OAD::ProcessEndpoint,
			     public PortableServer::RefCountServantBase
{
    CORBA::String_var name_;
    CORBA::String_var id_;
    CORBA::PolicyList pl_;
    PortableServer::POA_var poa_;
    OB::ORBControl_var orbControl_;

public:

    //
    // Constructor/destructor
    //
    ProcessEndpoint_impl(const char*, const char*, PortableServer::POA_ptr,
    			 OB::ORBControl_ptr);

    ~ProcessEndpoint_impl();

    //
    // Standard IDL to C++ Mapping
    //
    virtual void reestablish_link(OAD::ProcessEndpointManager_ptr)
        throw(CORBA::SystemException);

    virtual void stop()
        throw(CORBA::SystemException);

    PortableServer::POA_ptr _default_POA();
};

} // End namespace OAD

#endif
