// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/Object.h>
#include <OB/AbstractBase.h>

using namespace CORBA;
using namespace OB;

//
// The ids_ for Object
//
const char* Object::ids_[] =
{
    //
    // Don't put "IDL:omg.org/CORBA/Object:1.0" here, as this ID is
    // always implictly there.
    //
    0
};

// ----------------------------------------------------------------------
// External, non-inline duplicate/release for templates
// ----------------------------------------------------------------------

void
OBDuplicate(Object_ptr p)
{
    if(p)
	p -> _add_ref();
}

void
OBRelease(Object_ptr p)
{
    if(p)
	p -> _remove_ref();
}

// ----------------------------------------------------------------------
// Object constructor and destructor
// ----------------------------------------------------------------------

Object::Object()
{
}

Object::~Object()
{
}

// ----------------------------------------------------------------------
// Object public member implementation
// ----------------------------------------------------------------------

Object_ptr
Object::_narrow(AbstractBase_ptr a)
{
    if(!is_nil(a))
        return a -> _to_object();
    return _nil();
}

Object_ptr
Object::_unchecked_narrow(AbstractBase_ptr a)
{
    if(!is_nil(a))
        return a -> _to_object();
    return _nil();
}

const char**
Object::_OB_staticIds()
{
    return ids_;
}
