// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/NativeTypes.h>
#include <OB/Object.h>
#include <OB/ObjectIdHasher.h>

using namespace CORBA;

//-----------------------------------------------------------------------
// ObjectIdHasher hash/compare functions
//-----------------------------------------------------------------------

ULong
OBPortableServer::ObjectIdHasher::hash(const PortableServer::ObjectId& k)
{
     ULong h = 0;
     ULong offset = 0;
     Long len = (Long)k.length();

     if(len < 16)
     {
          for(Long i = len ; i > 0 ; i--)
              h = (h * 37) + (int)k[offset++];
     }
     else
     {
          ULong skip = len / 8;
          for(Long i = len ; i > 0 ; i -= skip, offset += skip)
              h = (h * 39) + (int)k[offset];
     }

     return h;
}

bool
OBPortableServer::ObjectIdHasher::comp(const PortableServer::ObjectId& k1,
                     		       const PortableServer::ObjectId& k2)
{
    return ((k1.length() == k2.length()) &&
            (memcmp(k1.get_buffer(), k2.get_buffer(), k1.length()) == 0));
}
