// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_SHARED_LIBRARY_H
#define OB_SHARED_LIBRARY_H

#include <OB/Basic.h>

#ifdef HAVE_SHL_LOAD
#include <dl.h>
#endif

namespace OB
{

class SharedLibrary
{
#ifdef WIN32
    HINSTANCE handle_;
#else
#  ifdef HAVE_SHL_LOAD
    shl_t handle_;
#  else
    void* handle_;
#  endif
#endif

    CORBA::String_var errmsg_;

public:

    SharedLibrary();
    ~SharedLibrary();

    bool open(const char*);

#ifdef WIN32
    typedef FARPROC proc_type;
#else
    typedef void* proc_type;
#endif

    proc_type findsym(const char*);

    char* error() const;
};

} // End namespace OB

#endif
