// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef IFR1_IMPL_H
#define IFR1_IMPL_H

#include <OB/IFR1_skel.h>

namespace CORBA
{

//
// Forward declarations
//
class Repository_impl;

//
// Some servant sequence types
//
class IDLType_impl;
typedef OB::FixSeq< IDLType_impl*, int > IDLTypeIS;
typedef OB::VarSeq< OB::FixSeq< IDLType_impl*, int >, int > IDLTypeISS;
class Contained_impl;
typedef OB::FixSeq< Contained_impl*, int > ContainedIS;
class ExceptionDef_impl;
typedef OB::FixSeq< ExceptionDef_impl*, int > ExceptionDefIS;
class InterfaceDef_impl;
typedef OB::FixSeq< InterfaceDef_impl*, int > InterfaceDefIS;
class ValueDef_impl;
typedef OB::FixSeq< ValueDef_impl*, int > ValueDefIS;

//
// The IRObject_impl class
//
class IRObject_impl : public virtual PortableServer::RefCountServantBase,
		      public virtual POA_CORBA::IRObject
{
protected:

    bool destroyed_;
    ORB_var orb_;
    PortableServer::POA_var poa_;
    Repository_impl* repository_;

public:

    IRObject_impl(ORB_ptr, PortableServer::POA_ptr, Repository_impl*);
    virtual ~IRObject_impl();

    virtual DefinitionKind def_kind()
        throw(SystemException) = 0;
    virtual void destroy()
        throw(SystemException);

    PortableServer::POA_ptr _default_POA();
};

//
// The IDLType_impl class
//
class IDLType_impl : public virtual POA_CORBA::IDLType,
		     public virtual IRObject_impl
{
public:

    IDLType_impl(ORB_ptr, PortableServer::POA_ptr, Repository_impl*);
    virtual ~IDLType_impl();

    virtual bool isAnonymous() = 0;

    virtual TypeCode_ptr type()
        throw(SystemException) = 0;
    virtual TypeCode_ptr typeRecursive(ContainedIS&)
        throw(SystemException) = 0;
};

} // End of namespace CORBA

#endif
