# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\idl$(LIBSUFFIX).lib
PDB_NAME	= $(top_srcdir)\lib\idl$(LIBSUFFIX).pdb

SERV_NAME	= $(top_srcdir)\bin\irserv.exe
FEED_NAME	= $(top_srcdir)\bin\irfeed.exe
DEL_NAME	= $(top_srcdir)\bin\irdel.exe
HIDL_NAME	= $(top_srcdir)\bin\hidl.exe
RIDL_NAME	= $(top_srcdir)\bin\ridl.exe


IDL_NAME	= $(top_srcdir)\bin\idl.exe
JIDL_NAME	= $(top_srcdir)\bin\jidl.exe
GEN_NAME	= $(top_srcdir)\bin\irgen.exe


UTILS		= $(IDL_NAME) \
		  $(JIDL_NAME) \
		  $(SERV_NAME) \
		  $(FEED_NAME) \
		  $(DEL_NAME) \
		  $(GEN_NAME) \
		  $(HIDL_NAME) \
		  $(RIDL_NAME)



#
# Work around the inference rules problem with nmake.
#
!ifndef BUILD_UTILS

PDB_FLAGS       = /Fd$(PDB_NAME)
TARGETS		= $(LIB_NAME)

!else

TARGETS 	= $(UTILS)
PDB_FILES       = $(UTILS:.exe=.pdb) \
		  $(PDB_NAME)

!endif

!include $(top_srcdir)\config\Make.rules.mak

SUBDIRS		= cpp


LIB_OBJS	= Util.obj \
		  Gram.obj \
		  GramUtil.obj \
		  Scan.obj \
		  IFR1_skel.obj \
		  IFR1_impl.obj \
		  IFR2_skel.obj \
		  IFR2_impl.obj \
		  IFR3_skel.obj \
		  IFR3_impl.obj \
		  IFR4_skel.obj \
		  IFR4_impl.obj \
		  GenUtil.obj \
		  AnyValue.obj \
		  GenTextBase.obj \
		  CPPUtil.obj

CPP_OBJS	= GenCPP.obj GenCPPFwdH.obj GenCPPH.obj GenCPPC.obj \
		  GenCPPSkelH.obj GenCPPSkelC.obj GenCPPTieH.obj \
		  GenCPPImplH.obj GenCPPImplC.obj GenCPPUtil.obj
GEN_OBJS	= Gen.obj $(CPP_OBJS)

SERV_OBJS	= Server.obj
FEED_OBJS	= Feed.obj
DEL_OBJS	= Del.obj
HIDL_OBJS	= HIDL.obj GenHTML.obj GenHTMLUtil.obj
RIDL_OBJS	= RIDL.obj GenRTF.obj GenRTFUtil.obj

IDL_OBJS	= IDL.obj $(CPP_OBJS)
JIDL_OBJS	= JIDL.obj GenJava.obj GenJavaUtil.obj


SERVICE_NAME	= $(top_srcdir)\bin\ntirservice.exe

SERVICE_OBJS =	  NTIRMain.obj \
		  NTIRService.obj \
		  IRMsg.res

LEX		= flex
YACC		= bison -y

DEF_NAME = idl$(LIBSUFFIX).def
DLL_NAME = $(top_srcdir)\lib\idl$(OB_LIBVER)$(LIBSUFFIX).dll
EXP_NAME = $(top_srcdir)\lib\idl$(LIBSUFFIX).exp

!ifndef BUILD_UTILS
ALL_CPPFLAGS    = /DOB_TRANSLATOR_IMPORT=/**/ /I.\wininclude /I. \
                  $(OB_CPPFLAGS) $(CPPFLAGS)
!else
ALL_CPPFLAGS    = /I. /Iwininclude $(OB_CPPFLAGS) $(CPPFLAGS)
!endif

ALL_CXXFLAGS    = $(CXXFLAGS)
ALL_LIBS        = $(LIB_NAME) $(OB_LIBS) $(LIBS)

!if "$(DLL)" == "yes"

ALL_DLLLIBS     = $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(DLL_NAME)

$(DEF_NAME):

$(DLL_NAME): $(LIB_OBJS) $(DEF_NAME)
        perl $(top_srcdir)\..\config\makedef.pl $(DEF_NAME) \
        idl$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
        $(LINK) $(LINKDLLFLAGS) /BASE:0x50000000 /def:$(DEF_NAME) \
        /IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS    = $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
        $(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

!endif

$(IDL_NAME): $(IDL_OBJS) $(LICENSING_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(IDL_OBJS) $(LICENSING_OBJS) $(ALL_LIBS) setargv.obj

$(JIDL_NAME): $(JIDL_OBJS) $(LICENSING_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(JIDL_OBJS) $(LICENSING_OBJS) $(ALL_LIBS) setargv.obj

$(GEN_NAME): $(GEN_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(GEN_OBJS) $(ALL_LIBS) setargv.obj


$(SERV_NAME): $(SERV_OBJS) $(LIB_NAME) $(OB_LIBS)
	$(LINK) $(LINKFLAGS) /out:$@ $(SERV_OBJS) $(ALL_LIBS) setargv.obj

$(FEED_NAME): $(FEED_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(FEED_OBJS) $(ALL_LIBS) setargv.obj

$(DEL_NAME): $(DEL_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(DEL_OBJS) $(ALL_LIBS) setargv.obj

$(HIDL_NAME): $(HIDL_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(HIDL_OBJS) $(ALL_LIBS) setargv.obj

$(RIDL_NAME): $(RIDL_OBJS)  $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(RIDL_OBJS) $(ALL_LIBS) setargv.obj

$(SERVICE_NAME): $(SERVICE_OBJS) $(LIB_NAME)
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVICE_OBJS) $(ALL_LIBS)

!ifdef BUILD_UTILS
all:: $(SERVICE_NAME)
!endif

clean:: 
	@if exist $(SERVICE_NAME) del $(SERVICE_NAME)
	@if exist $(SERVICE_NAME:.exe=.pdb) \
	del $(SERVICE_NAME:.exe=.pdb)

IRMsg.rc : IRMsg.mc
	mc IRMsg.mc

IRMsg.res: IRMsg.rc
	rc -r -fo IRMsg.res IRMsg.rc

IRMsg.h : IRMsg.rc

# Gram.cpp Gram.h: Gram.y
# 	$(YACC) -dvt Gram.y
# 	-del Gram.cpp 
# 	move y.tab.c Gram.cpp
# 	-del Gram.h 
# 	move y.tab.h Gram.h
# 
# Scan.cpp: Scan.l Gram.h
# 	$(LEX) Scan.l
# 	-del Scan.cpp 
# 	move lex.yy.c Scan.cpp
# 
# clean::
# 	-del Gram.cpp Gram.h Gram.output
# 	-del Scan.cpp lex.yy.c

!ifndef BUILD_UTILS

min:: all

install:: all

install_min:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_UTILS=1 $@

!else

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
	copy $(IDL_NAME) $(bindir)
	copy $(JIDL_NAME) $(bindir)
	copy $(GEN_NAME) $(bindir)
	copy $(HIDL_NAME) $(bindir)
	copy $(RIDL_NAME) $(bindir)
	copy $(SERV_NAME) $(bindir)
	copy $(FEED_NAME) $(bindir)
	copy $(DEL_NAME) $(bindir)
	copy $(SERVICE_NAME) $(bindir)

!if "$(DLL)" == "yes"

DLL_PDB = $(DLL_NAME:.dll=.pdb)

install:: all
        copy $(DLL_NAME) $(libdir)
        copy $(EXP_NAME) $(libdir)
        if exist $(DLL_PDB) copy $(DLL_PDB) $(libdir)

!endif

clean::
        -del $(DLL_NAME) $(EXP_NAME) $(DEF_NAME) $(DLL_NAME:.dll=.pdb)

min:: all

install_min:: install

$(EVERYTHING)::
	@for %i in ( $(SUBDIRS) ) do \
	    @cmd /c "cd %i & $(MAKE) /f Makefile.mak $@"

!endif

!include .windep
