// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ___URLTest_impl_h__
#define ___URLTest_impl_h__

#include <URLTest_skel.h>

//
// IDL:URLTest:1.0
//
namespace URLTest
{
PortableServer::ObjectId& strToKey(const char* start, const char* end,
				   PortableServer::ObjectId& key);
char* keyToStr(const OCI::ObjectKey& key, bool urlEscapeNulls);

char EncodeHex(int i);

// 
// Type of line termination to write to test file:// URLs.
// 
enum LineTerminator 
{
    NoEOL,                       // No terminator 
    UnixEOL,                    // '\n'
    Win32EOL,                   // '\r\n'
    UnixEOLExtraText,           // '\n' followed by comment text
    Win32EOLExtraText           // '\r\n' followed by comment text
};

// 
// Write out an IOR to a file using the specified line termination. 
// The file is unlinked when this object is destroyed.
// 
class TempIORFile
{
    CORBA::String_var fName_;

public:
    TempIORFile(CORBA::ORB_ptr orb, CORBA::Object_ptr obj,
		const char*iorFile, int ltor);
    ~TempIORFile();
    
};


//
// IDL:URLTest/IIOPAddress:1.0
//
class IIOPAddress_impl :
    virtual public POA_URLTest::IIOPAddress,
    virtual public PortableServer::RefCountServantBase
{
    IIOPAddress_impl(const IIOPAddress_impl&);
    void operator=(const IIOPAddress_impl&);

    CORBA::ORB_var orb_;
    CORBA::String_var host_;
    CORBA::Long port_;
    CORBA::String_var key_;
    CORBA::String_var str_;
    
public:

    IIOPAddress_impl(CORBA::ORB_ptr orb, const char* host, 
		     CORBA::Long port, const char* key, 
		     const char* str = "");
    ~IIOPAddress_impl();

    //
    // IDL:URLTest/IIOPAddress/getKey:1.0
    //
    virtual char* getKey()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/getPort:1.0
    //
    virtual CORBA::Long getPort()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/getHost:1.0
    //
    virtual char* getHost()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/getIIOPAddress:1.0
    //
    virtual char* getIIOPAddress()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/getCorbalocURL:1.0
    //
    virtual char* getCorbalocURL()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/destroy:1.0
    //
    virtual void destroy()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/setString:1.0
    //
    virtual void setString(const char* textStr)
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/getString:1.0
    //
    virtual char* getString()
        throw(CORBA::SystemException);

    //
    // IDL:URLTest/IIOPAddress/deactivate:1.0
    //
    virtual void deactivate()
        throw(CORBA::SystemException);
};

} // End of namespace URLTest

#endif
