// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef ___Test_impl_h__
#define ___Test_impl_h__

#include <Test_skel.h>

class Test_impl : virtual public POA_Test,
                  virtual public PortableServer::RefCountServantBase
{
    Test_impl(const Test_impl&);
    void operator=(const Test_impl&);

    CORBA::ORB_var orb_;

    PortableServer::POA_var poa_;

    Test_var localTest_;

public:

    Test_impl(CORBA::ORB_ptr, PortableServer::POA_ptr);
    ~Test_impl();

    virtual PortableServer::POA_ptr _default_POA();

    virtual void say(const char*)
        throw(CORBA::SystemException);

    virtual void intest(Test_ptr t)
        throw(CORBA::SystemException);

    virtual void inany(const CORBA::Any& a)
        throw(CORBA::SystemException);

    virtual void outany(CORBA::Any_out a)
        throw(CORBA::SystemException);

    virtual Test_ptr returntest()
        throw(CORBA::SystemException);

    virtual void shutdown()
	throw(CORBA::SystemException);
};

class LocalTest_impl : public LocalTest,
		       public OBCORBA::RefCountLocalObject
{
    LocalTest_impl(const LocalTest_impl&);
    void operator=(const LocalTest_impl&);

public:

    LocalTest_impl();
    ~LocalTest_impl();

    virtual void say(const char*)
        throw(CORBA::SystemException);

    virtual void intest(Test_ptr t)
        throw(CORBA::SystemException);

    virtual void inany(const CORBA::Any& a)
        throw(CORBA::SystemException);

    virtual void outany(CORBA::Any_out a)
        throw(CORBA::SystemException);

    virtual Test_ptr returntest()
        throw(CORBA::SystemException);

    virtual void shutdown()
        throw(CORBA::SystemException);
};

#endif
