# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..\..

LIB_NAME	= $(top_srcdir)\lib\obtestobv$(LIBSUFFIX).lib
PDB_NAME	= $(top_srcdir)\lib\obtestobv$(LIBSUFFIX).pdb

SERVER_NAME	= server.exe
CLIENT_NAME	= client.exe

!ifndef BUILD_EXE
TARGETS		= $(LIB_NAME)
PDB_FLAGS	= /Fd$(PDB_NAME)
!else
TARGETS 	= $(SERVER_NAME) \
		  $(CLIENT_NAME)

PDB_FILES       = $(TARGETS:.exe=.pdb) \
		  $(PDB_NAME)
!endif

!include $(top_srcdir)\config\Make.rules.mak

LIB_OBJS	= TestOBV.obj \
		  TestOBV_skel.obj \
		  Factories.obj \
		  TestAbstractSub_impl.obj \
		  TestCustom_impl.obj \
		  TestNode_impl.obj \
		  TestOBV_impl.obj \
		  TestOBVColo_impl.obj \
		  TestTrunc_impl.obj \
		  TestValue_impl.obj \
		  TestValueAI_impl.obj \
		  TestValueInterface_impl.obj \
		  Server.obj \
		  Client.obj

SERVER_OBJS	= ServerMain.obj

CLIENT_OBJS	= ClientMain.obj

GENERATED	= TestOBV.cpp \
		  TestOBV.h \
		  TestOBV_skel.cpp \
		  TestOBV_skel.h

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)
ALL_CPPFLAGS	= /I. /I..\include $(OB_CPPFLAGS) $(CPPFLAGS)
IDL_FLAGS	= -I$(IDLDIR)
ALL_LIBS	= $(LIB_NAME) $(OB_LIBS) $(LIBS)

$(LIB_NAME): $(LIB_OBJS)
	-del $@
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

$(SERVER_NAME): $(SERVER_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(SERVER_OBJS) $(ALL_LIBS)

$(CLIENT_NAME): $(CLIENT_OBJS) $(LIB_NAME)
	-del $@
	$(LINK) $(LINKFLAGS) /out:$@ $(CLIENT_OBJS) $(ALL_LIBS)

TestOBV.cpp TestOBV.h: TestOBV.idl
	-del TestOBV.cpp TestOBV.h
	-del TestOBV_skel.cpp TestOBV_skel.h
	$(IDL) $(IDL_FLAGS) TestOBV.idl

TestOBV_skel.cpp TestOBV_skel.h: TestOBV.cpp

!ifndef BUILD_EXE
install:: all

$(EVERYTHING)::
	$(MAKE) /f Makefile.mak BUILD_EXE=1 $@
!else
install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(PDB_NAME) copy $(PDB_NAME) $(libdir)
!endif


!include .windep
