// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <Test_impl.h>

using namespace CORBA;

// ----------------------------------------------------------------------
// Test_impl constructor and destructor
// ----------------------------------------------------------------------

Test_impl::Test_impl()
{
}

Test_impl::~Test_impl()
{
}

// ----------------------------------------------------------------------
// Test_impl public member implementation
// ----------------------------------------------------------------------

void
Test_impl::aMethod()
    throw(SystemException)
{
}

// ----------------------------------------------------------------------
// Retry_impl constructor and destructor
// ----------------------------------------------------------------------

Retry_impl::Retry_impl()
{
}

Retry_impl::~Retry_impl()
{
}

// ----------------------------------------------------------------------
// Retry_impl public member implementation
// ----------------------------------------------------------------------

void
Retry_impl::aMethod()
    throw(SystemException)
{
    count_++;

    if(max_ > 0 && count_ <= max_)
    {
        if(maybe_)
            throw TRANSIENT(0, COMPLETED_MAYBE);
        else
            throw TRANSIENT(0, COMPLETED_NO);
    }
}

ULong
Retry_impl::get_count()
    throw(SystemException)
{
    return count_;
}

void
Retry_impl::raise_exception(ULong max, Boolean maybe)
    throw(SystemException)
{
    count_ = 0;
    max_ = max;
    maybe_ = maybe;
}

// ----------------------------------------------------------------------
// RetryServer_impl constructor and destructor
// ----------------------------------------------------------------------

RetryServer_impl::RetryServer_impl(ORB_ptr orb, Test_ptr test,
                                   Retry_ptr retry)
    : orb_(ORB::_duplicate(orb)), test_(Test::_duplicate(test)),
      retry_(Retry::_duplicate(retry))
{
}

RetryServer_impl::~RetryServer_impl()
{
}

// ----------------------------------------------------------------------
// RetryServer_impl public member implementation
// ----------------------------------------------------------------------

Test_ptr
RetryServer_impl::get_location_forward_object()
    throw(SystemException)
{
    return Test::_duplicate(test_);
}

Retry_ptr
RetryServer_impl::get_retry_object()
    throw(SystemException)
{
    return Retry::_duplicate(retry_);
}

void
RetryServer_impl::deactivate()
    throw(SystemException)
{
    orb_ -> shutdown(false);
}
