// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>
#include <OB/IFR.h>
#include <Types.h>
#include <TestMacro.h>

using namespace CORBA;

void
TestTypeCode(ORB_ptr orb)
{
    {
	TCKind kind = _tc_completion_status -> kind();
	CHECK(kind == tk_enum);

	String_var name = _tc_completion_status -> name();
	CHECK(strcmp(name, "completion_status") == 0);

	String_var id = _tc_completion_status -> id();
	CHECK(strcmp(id, "IDL:omg.org/CORBA/completion_status:1.0") == 0);

	ULong count = _tc_completion_status -> member_count();
	CHECK(count == 3);

	String_var name0 = _tc_completion_status -> member_name(0);
	CHECK(strcmp(name0, "COMPLETED_YES") == 0);

	String_var name1 = _tc_completion_status -> member_name(1);
	CHECK(strcmp(name1, "COMPLETED_NO") == 0);

	String_var name2 = _tc_completion_status -> member_name(2);
	CHECK(strcmp(name2, "COMPLETED_MAYBE") == 0);
    }

    {
	TCKind kind = TypeCode::_tc_Bounds -> kind();
	CHECK(kind == tk_except);

	String_var name = TypeCode::_tc_Bounds -> name();
	CHECK(strcmp(name, "Bounds") == 0);

	String_var id = TypeCode::_tc_Bounds -> id();
	CHECK(strcmp(id, "IDL:omg.org/CORBA/TypeCode/Bounds:1.0") == 0);

	ULong count = TypeCode::_tc_Bounds -> member_count();
	CHECK(count == 0);
    }

    {
	TCKind kind = TypeCode::_tc_BadKind -> kind();
	CHECK(kind == tk_except);

	String_var name = TypeCode::_tc_BadKind -> name();
	CHECK(strcmp(name, "BadKind") == 0);

	String_var id = TypeCode::_tc_BadKind -> id();
	CHECK(strcmp(id, "IDL:omg.org/CORBA/TypeCode/BadKind:1.0") == 0);

	ULong count = TypeCode::_tc_BadKind -> member_count();
	CHECK(count == 0);
    }

    {
	TCKind kind = _tc_TestStruct1 -> kind();
	CHECK(kind == tk_struct);

	String_var name = _tc_TestStruct1 -> name();
	CHECK(strcmp(name, "TestStruct1") == 0);

	ULong count = _tc_TestStruct1 -> member_count();
	CHECK(count == 7);

	String_var name0 = _tc_TestStruct1 -> member_name(0);
	CHECK(strcmp(name0, "s") == 0);

	String_var name1 = _tc_TestStruct1 -> member_name(1);
	CHECK(strcmp(name1, "l") == 0);

	String_var name2 = _tc_TestStruct1 -> member_name(2);
	CHECK(strcmp(name2, "d") == 0);

	String_var name3 = _tc_TestStruct1 -> member_name(3);
	CHECK(strcmp(name3, "b") == 0);

	String_var name4 = _tc_TestStruct1 -> member_name(4);
	CHECK(strcmp(name4, "c") == 0);

	String_var name5 = _tc_TestStruct1 -> member_name(5);
	CHECK(strcmp(name5, "o") == 0);

	String_var name6 = _tc_TestStruct1 -> member_name(6);
	CHECK(strcmp(name6, "str") == 0);

	TypeCode_var type0 = _tc_TestStruct1 -> member_type(0);
	CHECK(type0 -> equal(_tc_short));

	TypeCode_var type1 = _tc_TestStruct1 -> member_type(1);
	CHECK(type1 -> equal(_tc_long));

	TypeCode_var type2 = _tc_TestStruct1 -> member_type(2);
	CHECK(type2 -> equal(_tc_double));

	TypeCode_var type3 = _tc_TestStruct1 -> member_type(3);
	CHECK(type3 -> equal(_tc_boolean));

	TypeCode_var type4 = _tc_TestStruct1 -> member_type(4);
	CHECK(type4 -> equal(_tc_char));

	TypeCode_var type5 = _tc_TestStruct1 -> member_type(5);
	CHECK(type5 -> equal(_tc_octet));

	TypeCode_var type6 = _tc_TestStruct1 -> member_type(6);
	CHECK(type6 -> equal(_tc_string));
    }

    {
	TCKind kind = _tc_TestStruct2 -> kind();
	CHECK(kind == tk_struct);

	String_var name = _tc_TestStruct2 -> name();
	CHECK(strcmp(name, "TestStruct2") == 0);

	ULong count = _tc_TestStruct2 -> member_count();
	CHECK(count == 4);

	String_var name0 = _tc_TestStruct2 -> member_name(0);
	CHECK(strcmp(name0, "s") == 0);

	TypeCode_var type0 = _tc_TestStruct2 -> member_type(0);
	CHECK(type0 -> equal(_tc_TestStruct1));

	String_var name1 = _tc_TestStruct2 -> member_name(1);
	CHECK(strcmp(name1, "a") == 0);

	TypeCode_var type1 = _tc_TestStruct2 -> member_type(1);
	CHECK(type1 -> equal(_tc_any));

	String_var name2 = _tc_TestStruct2 -> member_name(2);
	CHECK(strcmp(name2, "da") == 0);

	TypeCode_var type2 = _tc_TestStruct2 -> member_type(2);
	CHECK(type2 -> equal(_tc_DoubleArray));

	String_var name3 = _tc_TestStruct2 -> member_name(3);
	CHECK(strcmp(name3, "sa") == 0);

	TypeCode_var type3 = _tc_TestStruct2 -> member_type(3);
	//CHECK(type3 -> equal(_tc_...));
    }

    {
	TCKind kind = _tc_TestStruct3 -> kind();
	CHECK(kind == tk_struct);

	String_var name = _tc_TestStruct3 -> name();
	CHECK(strcmp(name, "TestStruct3") == 0);

	ULong count = _tc_TestStruct3 -> member_count();
	CHECK(count == 2);

	String_var name0 = _tc_TestStruct3 -> member_name(0);
	CHECK(strcmp(name0, "l") == 0);

	TypeCode_var type0 = _tc_TestStruct3 -> member_type(0);
	CHECK(type0 -> equal(_tc_long));

	String_var name1 = _tc_TestStruct3 -> member_name(1);
	CHECK(strcmp(name1, "seq") == 0);

	TypeCode_var type1 = _tc_TestStruct3 -> member_type(1);
	TypeCode_var contentType = type1 -> content_type();
	CHECK(contentType -> equal(_tc_TestStruct3));
    }

    {
	TCKind kind = _tc_TestStruct4 -> kind();
	CHECK(kind == tk_struct);

	String_var name = _tc_TestStruct4 -> name();
	CHECK(strcmp(name, "TestStruct4") == 0);

	ULong count = _tc_TestStruct4 -> member_count();
	CHECK(count == 2);

	String_var name0 = _tc_TestStruct4 -> member_name(0);
	CHECK(strcmp(name0, "a") == 0);

	TypeCode_var type0 = _tc_TestStruct4 -> member_type(0);
	CHECK(type0 -> equal(_tc_TestStruct3));

	String_var name1 = _tc_TestStruct4 -> member_name(1);
	CHECK(strcmp(name1, "b") == 0);

	TypeCode_var type1 = _tc_TestStruct4 -> member_type(1);
	TypeCode_var contentType = type1 -> content_type();
	CHECK(contentType -> equal(_tc_TestStruct3));
    }

    {
	TCKind kind = _tc_TestUnion4 -> kind();
	CHECK(kind == tk_union);

	String_var name = _tc_TestUnion4 -> name();
	CHECK(strcmp(name, "TestUnion4") == 0);

	ULong count = _tc_TestUnion4 -> member_count();
	CHECK(count == 2);

	String_var name0 = _tc_TestUnion4 -> member_name(0);
	CHECK(strcmp(name0, "seq") == 0);

	TypeCode_var type0 = _tc_TestUnion4 -> member_type(0);
	TypeCode_var contentType = type0 -> content_type();
	CHECK(contentType -> equal(_tc_TestUnion4));

	String_var name1 = _tc_TestUnion4 -> member_name(1);
	CHECK(strcmp(name1, "c") == 0);

	TypeCode_var type1 = _tc_TestUnion4 -> member_type(1);
	CHECK(type1 -> equal(_tc_char));

	Any_var label = _tc_TestUnion4 -> member_label(1);
	TypeCode_var labelType = label -> type();
	CHECK(labelType -> equal(_tc_short));
	Short labelValue;
	label >>= labelValue;
	CHECK(labelValue == 1);
    }

    {
	Any_var label = _tc_TestUnion1 -> member_label(
	    _tc_TestUnion1 -> default_index()
	    );
	Octet defaultValue;
	label >>= Any::to_octet(defaultValue);
	CHECK(defaultValue == 0);
    }

    {
	Any_var label = _tc_TestUnion2 -> member_label(0);
	TestEnum enumValue;
	label >>=enumValue;
	CHECK(enumValue == A);
    }

    {
	TypeCode_ptr p;

	p = _tc_RepositoryId;
	CHECK(strcmp(p -> name(), "RepositoryId") == 0);

	p = _tc_ScopedName;
	CHECK(strcmp(p -> name(), "ScopedName") == 0);

	p = _tc_Identifier;
	CHECK(strcmp(p -> name(), "Identifier") == 0);

	p = _tc_DefinitionKind;
	CHECK(strcmp(p -> name(), "DefinitionKind") == 0);

	p = _tc_IRObject;
	CHECK(strcmp(p -> name(), "IRObject") == 0);

	p = _tc_VersionSpec;
	CHECK(strcmp(p -> name(), "VersionSpec") == 0);

	p = _tc_Contained;
	CHECK(strcmp(p -> name(), "Contained") == 0);

	p = Contained::_tc_Description;
	CHECK(strcmp(p -> name(), "Description") == 0);

	p = _tc_InterfaceDefSeq;
	CHECK(strcmp(p -> name(), "InterfaceDefSeq") == 0);

	p = _tc_ContainedSeq;
	CHECK(strcmp(p -> name(), "ContainedSeq") == 0);

	p = _tc_StructMember;
	CHECK(strcmp(p -> name(), "StructMember") == 0);

	p = _tc_StructMemberSeq;
	CHECK(strcmp(p -> name(), "StructMemberSeq") == 0);

	p = _tc_UnionMember;
	CHECK(strcmp(p -> name(), "UnionMember") == 0);

	p = _tc_UnionMemberSeq;
	CHECK(strcmp(p -> name(), "UnionMemberSeq") == 0);

	p = _tc_EnumMemberSeq;
	CHECK(strcmp(p -> name(), "EnumMemberSeq") == 0);

	p = _tc_Container;
	CHECK(strcmp(p -> name(), "Container") == 0);

	p = Container::_tc_Description;
	CHECK(strcmp(p -> name(), "Description") == 0);

	p = Container::_tc_DescriptionSeq;
	CHECK(strcmp(p -> name(), "DescriptionSeq") == 0);

	p = _tc_IDLType;
	CHECK(strcmp(p -> name(), "IDLType") == 0);

	p = _tc_PrimitiveKind;
	CHECK(strcmp(p -> name(), "PrimitiveKind") == 0);

	p = _tc_Repository;
	CHECK(strcmp(p -> name(), "Repository") == 0);

	p = _tc_ModuleDef;
	CHECK(strcmp(p -> name(), "ModuleDef") == 0);

	p = _tc_ModuleDescription;
	CHECK(strcmp(p -> name(), "ModuleDescription") == 0);

	p = _tc_ConstantDef;
	CHECK(strcmp(p -> name(), "ConstantDef") == 0);

	p = _tc_ConstantDescription;
	CHECK(strcmp(p -> name(), "ConstantDescription") == 0);

	p = _tc_TypedefDef;
	CHECK(strcmp(p -> name(), "TypedefDef") == 0);

	p = _tc_TypeDescription;
	CHECK(strcmp(p -> name(), "TypeDescription") == 0);

	p = _tc_StructDef;
	CHECK(strcmp(p -> name(), "StructDef") == 0);

	p = _tc_UnionDef;
	CHECK(strcmp(p -> name(), "UnionDef") == 0);

	p = _tc_EnumDef;
	CHECK(strcmp(p -> name(), "EnumDef") == 0);

	p = _tc_AliasDef;
	CHECK(strcmp(p -> name(), "AliasDef") == 0);

	p = _tc_PrimitiveDef;
	CHECK(strcmp(p -> name(), "PrimitiveDef") == 0);

	p = _tc_StringDef;
	CHECK(strcmp(p -> name(), "StringDef") == 0);

	p = _tc_SequenceDef;
	CHECK(strcmp(p -> name(), "SequenceDef") == 0);

	p = _tc_ArrayDef;
	CHECK(strcmp(p -> name(), "ArrayDef") == 0);

	p = _tc_ExceptionDef;
	CHECK(strcmp(p -> name(), "ExceptionDef") == 0);

	p = _tc_ExceptionDescription;
	CHECK(strcmp(p -> name(), "ExceptionDescription") == 0);

	p = _tc_AttributeMode;
	CHECK(strcmp(p -> name(), "AttributeMode") == 0);

	p = _tc_AttributeDef;
	CHECK(strcmp(p -> name(), "AttributeDef") == 0);

	p = _tc_AttributeDescription;
	CHECK(strcmp(p -> name(), "AttributeDescription") == 0);

	p = _tc_OperationMode;
	CHECK(strcmp(p -> name(), "OperationMode") == 0);

	p = _tc_ParameterMode;
	CHECK(strcmp(p -> name(), "ParameterMode") == 0);

	p = _tc_ParameterDescription;
	CHECK(strcmp(p -> name(), "ParameterDescription") == 0);

	p = _tc_ParDescriptionSeq;
	CHECK(strcmp(p -> name(), "ParDescriptionSeq") == 0);

	p = _tc_ContextIdentifier;
	CHECK(strcmp(p -> name(), "ContextIdentifier") == 0);

	p = _tc_ContextIdSeq;
	CHECK(strcmp(p -> name(), "ContextIdSeq") == 0);

	p = _tc_ExceptionDefSeq;
	CHECK(strcmp(p -> name(), "ExceptionDefSeq") == 0);

	p = _tc_ExcDescriptionSeq;
	CHECK(strcmp(p -> name(), "ExcDescriptionSeq") == 0);

	p = _tc_OperationDef;
	CHECK(strcmp(p -> name(), "OperationDef") == 0);

	p = _tc_OperationDescription;
	CHECK(strcmp(p -> name(), "OperationDescription") == 0);

	p = _tc_RepositoryIdSeq;
	CHECK(strcmp(p -> name(), "RepositoryIdSeq") == 0);

	p = _tc_OpDescriptionSeq;
	CHECK(strcmp(p -> name(), "OpDescriptionSeq") == 0);

	p = _tc_AttrDescriptionSeq;
	CHECK(strcmp(p -> name(), "AttrDescriptionSeq") == 0);

	p = _tc_InterfaceDef;
	CHECK(strcmp(p -> name(), "InterfaceDef") == 0);

	p = InterfaceDef::_tc_FullInterfaceDescription;
	CHECK(strcmp(p -> name(), "FullInterfaceDescription") == 0);

	p = _tc_InterfaceDescription;
	CHECK(strcmp(p -> name(), "InterfaceDescription") == 0);
    }

    //
    // Check repository ID
    //
    {
        static const char* bogusIds[] = { "foo", ":foo", "foo:" };
        for(ULong i = 0 ; i < 3 ; i++)
        {
            try
            {
                StructMemberSeq members;
                members.length(1);
                members[0].name = string_dup("a");
                members[0].type = TypeCode::_duplicate(_tc_short);
                TypeCode_var dummy =
                    orb -> create_struct_tc(bogusIds[i], "foo", members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                UnionMemberSeq members;
                members.length(1);
                members[0].name = string_dup("a");
                members[0].type = TypeCode::_duplicate(_tc_short);
                members[0].label <<= (Short)1;
                TypeCode_var dummy =
                    orb -> create_union_tc(bogusIds[i], "foo", _tc_short,
                                           members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_alias_tc(bogusIds[i], "foo", _tc_short);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                StructMemberSeq members;
                members.length(1);
                members[0].name = string_dup("a");
                members[0].type = TypeCode::_duplicate(_tc_short);
                TypeCode_var dummy =
                    orb -> create_exception_tc(bogusIds[i], "foo", members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_interface_tc(bogusIds[i], "foo");
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                ValueMemberSeq members;
                TypeCode_var dummy =
                    orb -> create_value_tc(bogusIds[i], "foo", VM_NONE,
                                           TypeCode::_nil(), members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_value_box_tc(bogusIds[i], "foo", _tc_short);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_native_tc(bogusIds[i], "foo");
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_abstract_interface_tc(bogusIds[i], "foo");
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_local_interface_tc(bogusIds[i], "foo");
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }
        }
    }

    //
    // Check IDL name
    //
    {
        static const char* bogusNames[] = { "_foo", "1foo", "f.oo" };
        for(ULong i = 0 ; i < 3 ; i++)
        {
            try
            {
                StructMemberSeq members;
                members.length(1);
                members[0].name = string_dup("a");
                members[0].type = TypeCode::_duplicate(_tc_short);
                TypeCode_var dummy =
                    orb -> create_struct_tc("IDL:foo:1.0", bogusNames[i],
                                            members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                UnionMemberSeq members;
                members.length(1);
                members[0].name = string_dup("a");
                members[0].type = TypeCode::_duplicate(_tc_short);
                members[0].label <<= (Short)1;
                TypeCode_var dummy =
                    orb -> create_union_tc("IDL:foo:1.0", bogusNames[i],
                                           _tc_short, members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_alias_tc("IDL:foo:1.0", bogusNames[i],
                                           _tc_short);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                StructMemberSeq members;
                members.length(1);
                members[0].name = string_dup("a");
                members[0].type = TypeCode::_duplicate(_tc_short);
                TypeCode_var dummy =
                    orb -> create_exception_tc("IDL:foo:1.0", bogusNames[i],
                                               members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_interface_tc("IDL:foo:1.0", bogusNames[i]);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                ValueMemberSeq members;
                TypeCode_var dummy =
                    orb -> create_value_tc("IDL:foo:1.0", bogusNames[i],
                                           VM_NONE, TypeCode::_nil(), members);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_value_box_tc("IDL:foo:1.0", bogusNames[i],
                                               _tc_short);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_native_tc("IDL:foo:1.0", bogusNames[i]);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_abstract_interface_tc("IDL:foo:1.0",
                                                        bogusNames[i]);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                TypeCode_var dummy =
                    orb -> create_local_interface_tc("IDL:foo:1.0",
                                                     bogusNames[i]);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }
        }
    }

    //
    // Check illegal TypeCodes
    //
    {
        StructMemberSeq members;
        TypeCode_var exTC = orb -> create_exception_tc("IDL:ex:1.0", "ex",
                                                       members);
        TypeCode_ptr types[] = { _tc_null, _tc_void, exTC.in() };

        for(ULong i = 0 ; i < 3 ; i++)
        {

            try
            {
                StructMemberSeq seq;
                seq.length(1);
                seq[0].name = string_dup("v");
                seq[0].type = TypeCode::_duplicate(types[i]);
                orb -> create_struct_tc("IDL:foo:1.0", "foo", seq);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                UnionMemberSeq seq;
                seq.length(1);
                seq[0].name = string_dup("v");
                seq[0].type = TypeCode::_duplicate(_tc_long);
                seq[0].label <<= (Short)1;
                orb -> create_union_tc("IDL:foo:1.0", "foo", types[i], seq);
                CHECK(false);
            }
            catch(const BAD_PARAM&)
            {
                // Expected
            }

            try
            {
                UnionMemberSeq seq;
                seq.length(1);
                seq[0].name = string_dup("v");
                seq[0].type = TypeCode::_duplicate(types[i]);
                seq[0].label <<= (Short)1;
                orb -> create_union_tc("IDL:foo:1.0", "foo", _tc_short, seq);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                orb -> create_alias_tc("IDL:foo:1.0", "foo", types[i]);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                StructMemberSeq seq;
                seq.length(1);
                seq[0].name = string_dup("v");
                seq[0].type = TypeCode::_duplicate(types[i]);
                orb -> create_exception_tc("IDL:foo:1.0", "foo", seq);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                orb -> create_sequence_tc(0, types[i]);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                orb -> create_array_tc(1, types[i]);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                ValueMemberSeq seq;
                seq.length(1);
                seq[0].name = string_dup("v");
                seq[0].type = TypeCode::_duplicate(types[i]);
                seq[0].access = PUBLIC_MEMBER;
                orb -> create_value_tc("IDL:foo:1.0", "foo", VM_NONE,
                                       TypeCode::_nil(), seq);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }

            try
            {
                orb -> create_value_box_tc("IDL:foo:1.0", "foo", types[i]);
                CHECK(false);
            }
            catch(const BAD_TYPECODE&)
            {
                // Expected
            }
        }
    }
}

int
main(int argc, char* argv[])
{
    int status = EXIT_SUCCESS;
    ORB_var orb;

    try
    {
        //
        // Create ORB
        //
        orb = ORB_init(argc, argv);

	//
	// Run the test
	//
        OB_INFO("Testing TypeCode type... ");
        TestTypeCode(orb);
        OB_INFO_LN("Done!");
    }
    catch(const Exception& ex)
    {
        OB_ERROR(ex);
        status = EXIT_FAILURE;
    }

    if(!is_nil(orb))
    {
	try
	{
	    orb -> destroy();
	}
	catch(const Exception& ex)
	{
	    OB_ERROR(ex);
	    status = EXIT_FAILURE;
	}
    }

    return status;
}
