// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#include <OB/CORBA.h>

#include <FileTransfer_impl.h>

#include <stdlib.h>
#include <errno.h>

#ifdef HAVE_FSTREAM
#   include <fstream>
#else
#   include <fstream.h>
#endif

#ifdef HAVE_STD_IOSTREAM
using namespace std;
#endif

void
FileTransfer_impl::send(const char* fileName, const File& file)
    throw(CORBA::SystemException)
{
    FILE* fp = 0;
    if((fp = fopen(fileName, "wb")) == 0)
    {
        cerr << progName_ << ": can't open `" << fileName << "': "
             << strerror(errno) << endl;
	return;
    }

    fwrite((void*)file.get_buffer(), 1, file.length(), fp);
    fclose(fp);
}
