# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

LIB_NAME	= $(top_srcdir)\lib\OCI_udp$(LIBSUFFIX).lib

LIB_PDB_NAME	= $(top_srcdir)\lib\OCI_udp$(LIBSUFFIX).pdb

PDB_FLAGS       = /Fd$(LIB_PDB_NAME)

TARGETS		= $(LIB_NAME)

!include $(top_srcdir)\config\Make.rules.mak

IDLDIR		= $(top_srcdir)\idl
HDIR		= $(top_srcdir)\include\OB

LIB_OBJS	= UDPIOP.obj \
		  OCI_UDP.obj \
		  OCI_UDP_impl.obj \
		  OCI_UDP_init.obj \
		  PacketCollector.obj \
		  ServerPacketHandler.obj

#
# When not in DLL mode these symbols are also needed for clean target
#
LIB_DEF_NAME	= OCI_udp$(LIBSUFFIX).def
LIB_DLL_NAME    = $(top_srcdir)\lib\OCI_udp$(OB_LIBVER)$(LIBSUFFIX).dll
LIB_EXP_NAME    = $(top_srcdir)\lib\OCI_udp$(LIBSUFFIX).exp

ALL_CPPFLAGS	= /I. /I$(top_srcdir)\include $(OB_CPPFLAGS) $(CPPFLAGS) \
                  /DOB_UDP_IMPORT=/**/

ALL_CPPFLAGS = $(ALL_CPPFLAGS)

IDL_FLAGS       = -I$(IDLDIR) -I$(top_srcdir)\..\ob\idl --this-header-dir OB \
                  --dll-import OB_UDP_IMPORT

!if "$(DLL)" == "yes"

ALL_CXXFLAGS	= $(CXXFLAGS) 

ALL_DLLLIBS	= $(OB_LIBS) $(LIBS) $(OB_DLLLIBS) $(DLLLIBS)

$(LIB_NAME): $(LIB_DLL_NAME)

$(LIB_DEF_NAME):

$(LIB_DLL_NAME): $(LIB_OBJS) $(LIB_DEF_NAME)
	perl $(top_srcdir)\..\config\makedef.pl $(LIB_DEF_NAME) \
	OCI_udp$(OB_LIBVER)$(LIBSUFFIX) $(LIB_OBJS)
	$(LINK) $(LINKDLLFLAGS) /BASE:0x54000000 /def:$(LIB_DEF_NAME) \
	/IMPLIB:$(LIB_NAME) /out:$@ $(LIB_OBJS) $(ALL_DLLLIBS)

!else

ALL_CXXFLAGS	= $(CXXFLAGS) $(PDB_FLAGS)

$(LIB_NAME): $(LIB_OBJS)
	$(AR) $(ARFLAGS) /out:$@ $(LIB_OBJS)

!endif

UDPIOP.cpp $(HDIR)\UDPIOP.h: $(IDLDIR)\OB\UDPIOP.idl
	-del UDPIOP.cpp $(HDIR)\UDPIOP.h
	$(IDL) $(IDL_FLAGS) --no-type-codes --no-skeletons \
	$(IDLDIR)\OB\UDPIOP.idl
	move UDPIOP.h $(HDIR)

OCI_UDP.cpp $(HDIR)\OCI_UDP.h: $(IDLDIR)\OB\OCI_UDP.idl
	-del OCI_UDP.cpp $(HDIR)\OCI_UDP.h
	$(IDL) $(IDL_FLAGS) --no-skeletons $(IDLDIR)\OB\OCI_UDP.idl
	move OCI_UDP.h $(HDIR)

Config.h:
	echo /* dummy file */ > $@

install:: all
	copy $(LIB_NAME) $(libdir)
	if exist $(LIB_PDB_NAME) copy $(LIB_PDB_NAME) $(libdir)

!if "$(DLL)" == "yes"

LIB_DLL_PDB = $(LIB_DLL_NAME:.dll=.pdb)

install:: all
	copy $(LIB_DLL_NAME) $(libdir)
	copy $(LIB_EXP_NAME) $(libdir)
	if exist $(LIB_DLL_PDB) copy $(LIB_DLL_PDB) $(libdir)

!endif

clean::
	-del $(LIB_DLL_NAME) $(LIB_EXP_NAME) $(LIB_DEF_NAME) \
	$(LIB_DLL_NAME:.dll=.pdb)

min:: all

install_min:: install

!include .windep
