// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef OB_CORBAOUT_H
#define OB_CORBAOUT_H

namespace OB
{

// ---------------------------------------------------------------------
// A class to display various CORBA types
// ---------------------------------------------------------------------

class CorbaOut
{
    DynamicAny::DynAnyFactory_var factory_;
    CORBA::WString_var& str_;
    int level_;

public:

    //
    // Constructor/destructor
    //
    CorbaOut(DynamicAny::DynAnyFactory_ptr, CORBA::WString_var&);
    ~CorbaOut();

    //
    // Manage level
    //
    void down() { level_++; };
    void up() { level_--; };
    void skip();


    //
    // Display types
    //
    void display_IDL_TypeCode(CORBA::TypeCode_ptr);
    void show_name_TypeCode(CORBA::TypeCode_ptr);

    void display_DynAny(DynamicAny::DynAny_ptr);
    void show_DynAny_without_type(DynamicAny::DynAny_ptr);
    void show_DynAny(DynamicAny::DynAny_ptr);

    void display_Any(const CORBA::Any&);
    void show_Any(const CORBA::Any&);

};


} // End of namespace OB

#endif // OB_CORBAOUT_H
