// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef __OB_BalancerPolicy_impl_h__
#define __OB_BalancerPolicy_impl_h__

#include <OB/LocalObject.h>

#include <BalancerPolicies.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// IDL:ooc.com/LoadBalancing/MemberPolicy:1.0
//
class MemberPolicy_impl : public MemberPolicy,
			  public OBCORBA::RefCountLocalObject
{
    //
    // No copy-constructor or assignment operator
    //
    MemberPolicy_impl(const MemberPolicy_impl&);
    void operator=(const MemberPolicy_impl&);

    //
    // The member policy value
    //
    MemberPolicyValue value_;

public:

    MemberPolicy_impl(const MemberPolicyValue&);
    virtual ~MemberPolicy_impl();

    //
    // IDL to C++ Mapping
    //

    virtual MemberPolicyValue* value()
        throw(CORBA::SystemException);

    virtual CORBA::PolicyType policy_type()
        throw(CORBA::SystemException);

    virtual CORBA::Policy_ptr copy()
        throw(CORBA::SystemException);

    virtual void destroy()
        throw(CORBA::SystemException);
};

//
// The member policy factory.
//
class MemberPolicyFactory_impl : public PortableInterceptor::PolicyFactory,
				 public OBCORBA::RefCountLocalObject
{
public:

    //
    // IDL to C++ Mapping
    //

    virtual CORBA::Policy_ptr create_policy(CORBA::PolicyType type,
                                            const CORBA::Any& any)
	throw(CORBA::PolicyError);
};

} // End of namespace LoadBalancing

#endif
