// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

#ifndef __OB_LoadCalculator_impl_h__
#define __OB_LoadCalculator_impl_h__

#include <OB/LocalObject.h>
#include <OB/BalancerUtil.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// IDL:ooc.com/LoadBalancing/Util:1.0
//
namespace Util
{

//
// IDL:ooc.com/LoadBalancing/LoadCalculator:1.0
//
class LoadCalculator_impl : public LoadCalculator,
			    public OBCORBA::RefCountLocalObject,
			    public JTCMutex
{
    LoadCalculator_impl(const LoadCalculator_impl&);
    void operator=(const LoadCalculator_impl&);

    //
    // The number of active requests
    //
    CORBA::Long activeRequests_;

    //
    // The number of completed requests
    //
    CORBA::Long completedRequests_;

public:

    LoadCalculator_impl();
    virtual ~LoadCalculator_impl();

    //
    // A new request was made.
    //
    void newRequest();

    //
    // A request was completed.
    //
    void requestCompleted();

    //
    // IDL:ooc.com/LoadBalancing/Util/LoadCalculator/calculate_load:1.0
    //
    virtual CORBA::ULong calculate_load()
        throw(CORBA::SystemException);
};

} // End of namespace Util

} // End of namespace LoadBalancing

#endif
