// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// *********************************************************************

#ifndef __OB_UtilInitializer_h__
#define __OB_UtilInitializer_h__

#include <OB/LocalObject.h>
#include <OB/PortableInterceptor.h>

#include <UtilLogger_fwd.h>

//
// IDL:ooc.com/LoadBalancing:1.0
//
namespace LoadBalancing
{

//
// IDL:ooc.com/LoadBalancing/Util:1.0
//
namespace Util
{

//
// Forward declaration
//
class LoadInterceptor;
class LoadAlertInterceptor;

//
// ORB Initializer for installing the LoadInterceptor and
// LoadAlertInterceptor interceptors and registering the LoadAlert,
// LoadCalculator, and LoadUpdater local objects.
//
class UtilInitializer : public PortableInterceptor::ORBInitializer,
			public OBCORBA::RefCountLocalObject,
			public JTCMutex
{
    //
    // The logger
    //
    Logger_var logger_;

    //
    // The LoadInterceptor
    //
    PortableInterceptor::ServerRequestInterceptor_var loadDummy_;
    LoadInterceptor* loadInterceptor_;

    //
    // The LoadAlertInterceptor
    //
    PortableInterceptor::ServerRequestInterceptor_var loadAlertDummy_;
    LoadAlertInterceptor* loadAlertInterceptor_;

    //
    // The LoadUpdater frequency
    //
    CORBA::ULong updateFreq_;

    //
    // The LoadAlert expire time
    //
    CORBA::ULong alertExpire_;

    //
    // Create the LoadAlert?
    //
    bool createAlert_;

    //
    // Create the LoadUpdater?
    //
    bool createUpdater_;

    //
    // Create the LoadCalculator?
    //
    bool createCalculator_;

    //
    // Are the objects initialized?
    //
    bool initialized_;

public:
 
    UtilInitializer();
    ~UtilInitializer();

    //
    // IDL to C++ Mapping
    //

    virtual void
    pre_init(PortableInterceptor::ORBInitInfo_ptr)
    {
    }

    virtual void
    post_init(PortableInterceptor::ORBInitInfo_ptr info);
};

} // End of namespace Util

} // End of namespace LoadBalancing

#endif
