// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

#ifndef COS_TIME_IMPL_H
#define COS_TIME_IMPL_H

#include <OB/LocalObject.h>

class TimeService_impl : public CosTime::TimeService,
			 public OBCORBA::RefCountLocalObject
{
    //
    // Inaccuracy in 100 ns units as defined by the user
    //
    TimeBase::InaccuracyT inaccuracy_;

public:

    TimeService_impl(TimeBase::InaccuracyT)
	throw(CORBA::SystemException);
        

    //
    // Standard IDL to C++ Mapping
    //
    virtual CosTime::UTO_ptr universal_time()
        throw(CosTime::TimeUnavailable, CORBA::SystemException);

    virtual CosTime::UTO_ptr secure_universal_time()
        throw(CosTime::TimeUnavailable, CORBA::SystemException);

    virtual CosTime::UTO_ptr new_universal_time(TimeBase::TimeT,
						TimeBase::InaccuracyT,
						TimeBase::TdfT)
        throw(CORBA::SystemException);

    virtual CosTime::UTO_ptr uto_from_utc(const TimeBase::UtcT&)
        throw(CORBA::SystemException);

    virtual CosTime::TIO_ptr new_interval(TimeBase::TimeT, TimeBase::TimeT)
        throw(CORBA::SystemException);
};

#endif
